VERSION 5.00
Begin VB.UserControl DetailsAlias 
   ClientHeight    =   4965
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3975
   ScaleHeight     =   4965
   ScaleWidth      =   3975
   ToolboxBitmap   =   "DetailsAlias.ctx":0000
   Begin VB.TextBox txtCommand 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   11.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2535
      Left            =   0
      MultiLine       =   -1  'True
      TabIndex        =   2
      Top             =   1440
      Width           =   3495
   End
   Begin VB.TextBox txtPattern 
      Height          =   285
      Left            =   0
      TabIndex        =   1
      Top             =   840
      Width           =   3495
   End
   Begin VB.TextBox txtName 
      Height          =   285
      Left            =   0
      TabIndex        =   0
      Top             =   240
      Width           =   3495
   End
   Begin VB.CheckBox Active 
      Caption         =   "Active"
      Height          =   255
      Left            =   0
      TabIndex        =   4
      Top             =   4320
      Value           =   1  'Checked
      Width           =   855
   End
   Begin VB.CheckBox CaseSensitive 
      Caption         =   "Case sensitive"
      Height          =   255
      Left            =   0
      TabIndex        =   3
      Top             =   4080
      Width           =   1335
   End
   Begin VB.CheckBox SimpleSyntax 
      Caption         =   "Simple Pattern"
      Height          =   255
      Left            =   0
      TabIndex        =   5
      Top             =   4560
      Width           =   1335
   End
   Begin VB.Label Label3 
      Caption         =   "Pattern:"
      Height          =   255
      Left            =   0
      TabIndex        =   8
      Top             =   600
      Width           =   615
   End
   Begin VB.Label Label4 
      Caption         =   "Commands:"
      Height          =   255
      Left            =   0
      TabIndex        =   7
      Top             =   1200
      Width           =   1575
   End
   Begin VB.Label lblName 
      Caption         =   "Alias Name:"
      Height          =   255
      Left            =   0
      TabIndex        =   6
      Top             =   0
      Width           =   1215
   End
End
Attribute VB_Name = "DetailsAlias"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private oAlias As Alias
Private sKey As String
Public Event Change(objAlias As Alias, ByRef strKey As String)


Public Sub Init(objAlias As Alias, strKey As String)
    On Error GoTo errHandler
    If Not objAlias Is oAlias Then Update 'auto update when necesarry
    Set oAlias = objAlias
    sKey = strKey
    If Not oAlias Is Nothing Then 'if not new
        txtName.Text = oAlias.Name
        txtPattern.Text = oAlias.Pattern
        txtCommand.Text = oAlias.Command
        Active.Value = oAlias.Enabled And 1
        CaseSensitive.Value = oAlias.CaseSensitive And 1
        SimpleSyntax.Value = oAlias.Simple And 1
    Else
        txtName.Text = ""
        txtPattern.Text = ""
        txtCommand.Text = ""
        Active.Value = 1
        CaseSensitive.Value = 0
        SimpleSyntax.Value = 1
    End If
    Exit Sub
errHandler:
    ErrorIn "DetailsAlias.Init(objAlias,strKey)", Array(objAlias, strKey)
End Sub

Private Sub UserControl_ExitFocus()
    On Error GoTo errHandler
   Update 'auto update when necesarry
    Exit Sub
errHandler:
    ErrorIn "DetailsAlias.UserControl_ExitFocus", , EA_EXTERNCALL
    HandleError
End Sub

Private Sub UserControl_Hide()
    On Error GoTo errHandler
    Set oAlias = Nothing
    txtName.Text = ""
    sKey = ""
    Exit Sub
errHandler:
    ErrorIn "DetailsAlias.UserControl_Hide", , EA_EXTERNCALL
    HandleError
End Sub

Private Sub UserControl_Resize()
    On Error Resume Next
    txtName.Width = UserControl.ScaleWidth
    txtCommand.Width = UserControl.ScaleWidth
    txtPattern.Width = UserControl.ScaleWidth
    SimpleSyntax.Top = UserControl.ScaleHeight - SimpleSyntax.Height
    Active.Top = SimpleSyntax.Top - Active.Height
    CaseSensitive.Top = Active.Top - CaseSensitive.Height
    txtCommand.Height = CaseSensitive.Top - txtCommand.Top
End Sub

Public Sub Update()
    On Error GoTo errHandler
    If oAlias Is Nothing Then 'if not new
        If Trim(txtName.Text) = "" Then Exit Sub
        Set oAlias = New Alias
    End If
    With oAlias
        On Error Resume Next
        .Enabled = False 'disable the syntax check while updating
        .CaseSensitive = (CaseSensitive.Value = 1)
        .Simple = (SimpleSyntax.Value = 1)
        .Pattern = txtPattern.Text
        .Name = txtName.Text
        .Command = txtCommand.Text
        .Enabled = (Active.Value = 1) And (Err.Number = 0)
        If Err.Number <> 0 Then
            MsgBox "Error during update:" & vbCrLf & vbCrLf & Err.Description, , "MonkeyTerm"
        End If

    End With
    RaiseEvent Change(oAlias, sKey)
    Exit Sub
errHandler:
    ErrorIn "DetailsAlias.Update"
End Sub


