VERSION 5.00
Begin VB.UserControl DetailsEvents 
   ClientHeight    =   5685
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4395
   ScaleHeight     =   5685
   ScaleWidth      =   4395
   Begin VB.CheckBox SimpleSyntax 
      Caption         =   "Simple Pattern"
      Height          =   255
      Left            =   0
      TabIndex        =   5
      Top             =   4560
      Width           =   1335
   End
   Begin VB.CheckBox CaseSensitive 
      Caption         =   "Case sensitive"
      Height          =   255
      Left            =   0
      TabIndex        =   3
      Top             =   4080
      Width           =   1335
   End
   Begin VB.CheckBox Active 
      Caption         =   "Active"
      Height          =   255
      Left            =   0
      TabIndex        =   4
      Top             =   4320
      Value           =   1  'Checked
      Width           =   855
   End
   Begin VB.TextBox txtName 
      Height          =   285
      Left            =   0
      TabIndex        =   0
      Top             =   240
      Width           =   3495
   End
   Begin VB.TextBox txtPattern 
      Height          =   285
      Left            =   0
      TabIndex        =   1
      Top             =   840
      Width           =   3495
   End
   Begin VB.TextBox txtCommand 
      Height          =   2535
      Left            =   0
      MultiLine       =   -1  'True
      TabIndex        =   2
      Top             =   1440
      Width           =   3495
   End
   Begin VB.Label lblName 
      Caption         =   "Event Name:"
      Height          =   255
      Left            =   0
      TabIndex        =   8
      Top             =   0
      Width           =   1215
   End
   Begin VB.Label Label4 
      Caption         =   "Commands:"
      Height          =   255
      Left            =   0
      TabIndex        =   7
      Top             =   1200
      Width           =   1575
   End
   Begin VB.Label Label3 
      Caption         =   "Pattern:"
      Height          =   255
      Left            =   0
      TabIndex        =   6
      Top             =   600
      Width           =   615
   End
End
Attribute VB_Name = "DetailsEvents"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private oEvent As clsEvent
Private sKey As String
Public Event Change(objEvent As clsEvent, strKey As String)

Public Sub Init(objEvent As clsEvent, strKey As String)
    If Not objEvent Is oEvent Then Update 'auto update when necesarry
    Set oEvent = objEvent
    sKey = strKey
    If Not oEvent Is Nothing Then 'if not new
        txtName.Text = oAction.ICollectionItem_Name
        txtPattern.Text = oAction.ICollectionItem_Pattern
        txtCommand.Text = oAction.ICollectionItem_Command
        Active.Value = oAction.ICollectionItem_Enabled And 1
        CaseSensitive.Value = oAction.ICollectionItem_CaseSensitive And 1
        SimpleSyntax.Value = oAction.ICollectionItem_Simple And 1
    Else
        txtName.Text = ""
        txtPattern.Text = ""
        txtCommand.Text = ""
        Active.Value = 1
        CaseSensitive.Value = 0
        SimpleSyntax.Value = 1
    End If
End Sub

Private Sub UserControl_ExitFocus()
   Update 'auto update when necesarry
End Sub

Private Sub UserControl_Resize()
    On Error Resume Next
    txtName.Width = UserControl.ScaleWidth
    txtCommand.Width = UserControl.ScaleWidth
    txtPattern.Width = UserControl.ScaleWidth
    SimpleSyntax.Top = UserControl.ScaleHeight - SimpleSyntax.Height
    Active.Top = SimpleSyntax.Top - Active.Height
    CaseSensitive.Top = Active.Top - CaseSensitive.Height
    txtCommand.Height = CaseSensitive.Top - txtCommand.Top
End Sub

Public Sub Update()
    If oAction Is Nothing Then 'if not new
        If Trim(txtName.Text) = "" Then Exit Sub
        Set oAction = New Action
    End If
    With oAction
        .ICollectionItem_Enabled = (Active.Value = 1)
        .ICollectionItem_CaseSensitive = (CaseSensitive.Value = 1)
        .ICollectionItem_Pattern = txtPattern.Text
        .ICollectionItem_Name = txtName.Text
        .ICollectionItem_Simple = (SimpleSyntax.Value = 1)
        .ICollectionItem_Command = txtCommand.Text
    End With
    RaiseEvent Change(oAction, sKey)
End Sub



