VERSION 5.00
Begin VB.UserControl DetailsKeyBinding 
   ClientHeight    =   5700
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4005
   ScaleHeight     =   5700
   ScaleWidth      =   4005
   ToolboxBitmap   =   "DetailsKeyBinding.ctx":0000
   Begin VB.TextBox txtCommand 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   11.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2535
      Left            =   0
      MultiLine       =   -1  'True
      TabIndex        =   2
      Top             =   840
      Width           =   3495
   End
   Begin VB.TextBox txtName 
      Height          =   285
      Left            =   0
      TabIndex        =   1
      Top             =   240
      Width           =   3495
   End
   Begin VB.CheckBox Active 
      Caption         =   "Active"
      Height          =   255
      Left            =   0
      TabIndex        =   0
      Top             =   3480
      Value           =   1  'Checked
      Width           =   855
   End
   Begin VB.Label Label4 
      Caption         =   "Commands:"
      Height          =   255
      Left            =   0
      TabIndex        =   4
      Top             =   600
      Width           =   1575
   End
   Begin VB.Label lblName 
      Caption         =   "Key combination:"
      Height          =   255
      Left            =   0
      TabIndex        =   3
      Top             =   0
      Width           =   1215
   End
End
Attribute VB_Name = "DetailsKeyBinding"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private oKeyBind As KeyBinding
Private sKey As String
Private iShift As Integer
Private iKeyCode As Integer

Public Event Change(objKeyBind As KeyBinding, ByRef strKey As String)

Public Sub Flush()
    On Error GoTo errHandler
    Set oKeyBind = Nothing
    sKey = ""
    Exit Sub
errHandler:
    ErrorIn "DetailsKeyBinding.Flush"
End Sub

Public Sub Init(objKeyBind As KeyBinding, strKey As String)
    On Error GoTo errHandler
    If Not objKeyBind Is oKeyBind Then Update 'auto update when necesarry
    
    Set oKeyBind = objKeyBind
    sKey = strKey
    If Not oKeyBind Is Nothing Then 'if not new
        iKeyCode = oKeyBind.KeyCode
        iShift = oKeyBind.Shift
        txtName.Text = oKeyBind.GetKeyCombination
        txtCommand.Text = oKeyBind.Command
        Active.Value = (oKeyBind.Enabled And 1)
    Else
        txtName.Text = ""
        txtCommand.Text = ""
        Active.Value = 1
    End If
    Exit Sub
errHandler:
    ErrorIn "DetailsKeyBinding.Init(objKeyBind,strKey)", Array(objKeyBind, strKey)
End Sub



Private Sub txtName_KeyUp(KeyCode As Integer, Shift As Integer)
    On Error GoTo errHandler
    Dim oTempKeyBind As KeyBinding
    If Not (KeyCode = 16 Or KeyCode = 17 Or KeyCode = 18) Then
        Set oTempKeyBind = New KeyBinding
        iShift = Shift
        iKeyCode = KeyCode
        oTempKeyBind.KeyCode = KeyCode
        oTempKeyBind.Shift = Shift
        txtName.Text = oTempKeyBind.GetKeyCombination
    End If
    Exit Sub
errHandler:
    ErrorIn "DetailsKeyBinding.txtName_KeyUp(KeyCode,Shift)", Array(KeyCode, Shift), EA_EXTERNCALL
    HandleError
End Sub

Private Sub UserControl_ExitFocus()
    On Error GoTo errHandler
   Update 'auto update when necesarry
    Exit Sub
errHandler:
    ErrorIn "DetailsKeyBinding.UserControl_ExitFocus", , EA_EXTERNCALL
    HandleError
End Sub

Private Sub UserControl_Hide()
    On Error GoTo errHandler
    Set oKeyBind = Nothing
    txtName.Text = ""
    sKey = ""
    Exit Sub
errHandler:
    ErrorIn "DetailsKeyBinding.UserControl_Hide", , EA_EXTERNCALL
    HandleError
End Sub

Private Sub UserControl_Resize()
    On Error Resume Next
    txtName.Width = UserControl.ScaleWidth
    txtCommand.Width = UserControl.ScaleWidth
    Active.Top = UserControl.ScaleHeight - Active.Height
    txtCommand.Height = Active.Top - txtCommand.Top
End Sub

Public Sub Update()
    On Error GoTo errHandler
    If oKeyBind Is Nothing Then 'if not new
        If Trim(txtName.Text) = "" Then Exit Sub
        Set oKeyBind = New KeyBinding
    End If
    With oKeyBind
        .Enabled = (Active.Value = 1)
        .Command = txtCommand.Text
        .KeyCode = iKeyCode
        .Shift = iShift
    End With
    RaiseEvent Change(oKeyBind, sKey)
    Exit Sub
errHandler:
    ErrorIn "DetailsKeyBinding.Update"
End Sub




