VERSION 5.00
Begin VB.UserControl EventDetails 
   ClientHeight    =   4305
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   7650
   ScaleHeight     =   4305
   ScaleWidth      =   7650
   Begin VB.CheckBox chkEnabled 
      Caption         =   "Enabled"
      Height          =   255
      Left            =   0
      TabIndex        =   2
      Top             =   3000
      Width           =   975
   End
   Begin VB.TextBox txtCommand 
      Height          =   2655
      Left            =   0
      TabIndex        =   1
      Text            =   "Command"
      Top             =   240
      Width           =   2775
   End
   Begin VB.Label lblEventName 
      Caption         =   "EventName"
      Height          =   255
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   2655
   End
End
Attribute VB_Name = "EventDetails"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Private oSessios As frmSession
Private oEvent As clsEvent

Public Sub Init(objEvent As clsEvent, objSession As frmSession)
    Dim vParams As Variant
    Set oSession = objSession
    Set oEvent = objEvent
    lblEventName.Caption = oEvent.Name
    vParams = oEvent.GetParameterNames
    If IsArray(vParams) Then
        lblEventName.Caption = oEvent.Name & "(" & Join(vParams, ",") & ")"
    End If
    txtCommand.Text = oEvent.Command
    chkEnabled.Value = (oEvent.Enabled And 1)
End Sub

Public Sub Save()
    If oEvent Is Nothing Then
        Beep
        Exit Sub
    End If
    oEvent.Enabled = txtCommand.Text
    chkEnabled.Value = (oEvent.Enabled And 1)
End Sub

Private Sub UserControl_Resize()
    On Error Resume Next
    txtCommand.Width = UserControl.ScaleWidth
    lblEventName.Width = UserControl.ScaleWidth
    
End Sub
