VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Web"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'// This object holds pointers to everything linked to the webpart of MonkeyTerm.

Private SessionObject As frmSession
Private objBrowser As BrowserControl
Private objServer As MTWebServer.WebServer
Private objResponse As MTWebServer.Response
Private objRequest As MTWebServer.Request
Friend Sub Init(SessionForm As frmSession)
    On Error GoTo errHandler
    Set SessionObject = SessionForm
    Set objBrowser = SessionForm.Browser
    Set objServer = Application.WebServer
    Exit Sub
errHandler:
    ErrorIn "Web.Init(SessionForm)", SessionForm
End Sub

Public Property Get Doc() As Object
'// Returns the document object of the browser. Equivalent to Web.Browser.IE.document
    Set Doc = objBrowser.IE.Document
End Property

Public Property Get Browser() As BrowserControl
'// Returns the browser object.
    Set Browser = objBrowser
End Property

Public Property Get Server() As MTWebServer.WebServer
'// Returns the webserver object.
    Set Server = objServer
End Property

'Friend Property Set Response(Response As MTWebServer.Response)
'    Set objResponse = Response
'End Property

Friend Sub LoadRequest(Response As MTWebServer.Response, Request As MTWebServer.Request)
    Set objResponse = Response
    Set objRequest = Request
End Sub

Friend Sub UnloadRequest()
    Set objResponse = Nothing
    Set objRequest = Nothing
End Sub

Public Property Get Response() As MTWebServer.Response
'// Use the response object to build the web response. This is active during a web-event.
'// <i>Append(s As String)</i>: Appends a string to the response object. Use this to build a page by appending all the content.
'// <i>Filename(ByVal vData As String)</i>: Reads or writes the filename. This can be used to respond the content of a file. It overwrites any leading or trailing calls to Append().
'// <i>Redirect(ByVal sUrl As String)</i>: Redirects the response to a new URL.
'// <i>Headers</i>: Returns a collection of headers. The items in the collections can be read or written.
'// <i>Mimetype(ByVal vData As String)</i>: Reads or writes the "Content-Type" Header.
'// <i>Flush</i>: Flushes the current response.
'// <i>GetContents</i>: Returns the whole response as a string, including headers.
    Set Response = objResponse
End Property

Public Property Get Request() As MTWebServer.Request
'// Used to read the web request. This is active durins a web-event.
'// <i>Values</i>: Returns a collection or GET and POST variables. It is also the default value of the request object, so it can also be read with web.request(paramname)
'// <i>Headers</i>: Returns a collection of headers.
    Set Request = objRequest
End Property
