VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Request"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit


'local variable(s) to hold property value(s)
Private oValues As New StringCollection 'local copy
Private oHeaders As New StringCollection 'local copy
Private sUrl As String 'local copy

Public Property Let URL(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.URL = 5
    sUrl = vData
End Property


Public Property Get URL() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.URL
    URL = sUrl
End Property

Public Property Get Headers() As StringCollection
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Headers
    Set Headers = oHeaders
End Property

Public Property Get Values() As StringCollection
Attribute Values.VB_UserMemId = 0
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Values
    Set Values = oValues
End Property

Friend Sub ParseHeader(sHeader As String)
    Dim sLines() As String
    Dim sLine() As String
    Dim l As Long
    sLines = Split(sHeader, vbCrLf)
    For l = 0 To UBound(sLines)
        sLine = Split(sLines(l), ":")
        oHeaders.Add sLine(0), sLine(1)
    Next
End Sub

Friend Sub ParseURL(sFullURL As String)
    Dim sParams() As String
    Dim sTemp() As String
    Dim lPos As Long
    Dim l As Long
    lPos = InStr(sFullURL, "?")
    If lPos = 0 Then lPos = Len(sFullURL) + 1
    sUrl = URLDecode(Left(sFullURL, lPos - 1))
    If lPos < Len(sFullURL) Then
        ParseParams (Mid(sFullURL, lPos + 1))
    End If
End Sub

Friend Sub ParseParams(sParamString As String)
    Dim sParams() As String
    Dim l As Long
    Dim sKey As String
    Dim sVal As String
    Dim sTemp() As String
    If Len(sParamString) > 0 Then
        sParams = Split(sParamString, "&")
        For l = 0 To UBound(sParams)
            sTemp = Split(sParams(l), "=")
            If UBound(sTemp) >= 0 Then
                If UBound(sTemp) > 0 Then
                    sVal = URLDecode(sTemp(1))
                Else
                    sVal = ""
                End If
                sKey = URLDecode(sTemp(0))
                If oValues.Exists(sKey) Then
                    oValues.item(sKey) = oValues.item(sKey) & ", " & sVal
                    'multiselects mm.
                Else
                    oValues.item(sKey) = sVal
                End If
            End If
        Next
    End If
End Sub
