Attribute VB_Name = "modHTTP"
Option Explicit



Public Function URLDecode(sUrl As String) As String
    On Error GoTo ErrorHandler
    Dim l As Long
    Dim lEscapePos As Long
    Dim c As String
    Dim sOut As String
    Dim lOutLen As Long
    sOut = Space(Len(sUrl))
    lEscapePos = -1000
    For l = 1 To Len(sUrl)
        c = Mid(sUrl, l, 1)
        lOutLen = lOutLen + 1
        If c = "%" Then lEscapePos = l
        If l = lEscapePos + 2 Then
            c = Chr(CByte("&H" & Mid(sUrl, lEscapePos + 1, 2)))
            lEscapePos = -1000
            lOutLen = lOutLen - 2
        End If
        Mid(sOut, lOutLen, 1) = c
    Next
    URLDecode = sOut
Exit Function
ErrorHandler:
    URLDecode = sUrl
End Function

Public Sub ParseURL(sUrl As String, ByRef sFile As String, ByRef oRequest As StringCollection)
    If oRequest Is Nothing Then Set oRequest = New StringCollection
    Dim sParams() As String
    Dim sTemp() As String
    Dim lPos As Long
    Dim l As Long
    lPos = InStr(sUrl, "?")
    If lPos = 0 Then lPos = Len(sUrl) + 1
    sFile = URLDecode(Left(sUrl, lPos - 1))
    If lPos < Len(sUrl) Then
        sParams = Split(Mid(sUrl, lPos + 1), "&")
        For l = 0 To UBound(sParams)
            sTemp = Split(sParams(l), "=")
            oRequest.Add URLDecode(sTemp(0)), URLDecode(sTemp(1))
        Next
    End If
End Sub

