VERSION 5.00
Begin VB.Form frmAbout 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "About Monkey Term"
   ClientHeight    =   4710
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5430
   ClipControls    =   0   'False
   Icon            =   "frmAbout.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   Picture         =   "frmAbout.frx":346A
   ScaleHeight     =   4710
   ScaleWidth      =   5430
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Tag             =   "About Monkey Term"
   Begin VB.Frame frScrollClipper 
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      Height          =   2055
      Left            =   120
      TabIndex        =   3
      Top             =   1920
      Width           =   5175
      Begin VB.Frame frScrollRegion 
         Appearance      =   0  'Flat
         BackColor       =   &H00000000&
         ForeColor       =   &H80000008&
         Height          =   1815
         Left            =   120
         TabIndex        =   4
         Top             =   120
         Width           =   4935
         Begin VB.Label lblPersons 
            Alignment       =   2  'Center
            BackColor       =   &H00008000&
            Caption         =   "This region should scroll"
            BeginProperty Font 
               Name            =   "Verdana"
               Size            =   9.75
               Charset         =   0
               Weight          =   700
               Underline       =   0   'False
               Italic          =   0   'False
               Strikethrough   =   0   'False
            EndProperty
            ForeColor       =   &H0080FF80&
            Height          =   300
            Index           =   0
            Left            =   360
            TabIndex        =   5
            Top             =   240
            Width           =   2775
         End
      End
   End
   Begin VB.Timer AboutTimer 
      Interval        =   30
      Left            =   3840
      Top             =   4200
   End
   Begin VB.CommandButton cmdOK 
      Cancel          =   -1  'True
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   345
      Left            =   4800
      TabIndex        =   0
      Tag             =   "OK"
      Top             =   4260
      Width           =   510
   End
   Begin VB.Label lblCompany 
      BackStyle       =   0  'Transparent
      Caption         =   "1999-2002 Aslak Grinsted and Per Schierbeck"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      ToolTipText     =   "Greetings go out to all eternals on AstroMud"
      Top             =   4200
      Width           =   3615
   End
   Begin VB.Label lblVersion 
      BackStyle       =   0  'Transparent
      Caption         =   "Version"
      Height          =   225
      Left            =   120
      TabIndex        =   1
      Tag             =   "Version"
      Top             =   4440
      Width           =   2175
   End
End
Attribute VB_Name = "frmAbout"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const CharsPrLine = 37
Private Persons As String
Private PersonList() As String
Private sngCurTop As Single

Private Sub Form_DblClick()
    On Error GoTo errHandler
    Application.Media.ShellOpen "http://www.eternals.dk/monkeyterm"
    Exit Sub
errHandler:
    ErrorIn "frmAbout.Form_DblClick", , EA_EXTERNCALL
    HandleError
End Sub

Private Sub cmdOK_Click()
    On Error GoTo errHandler
    Unload Me
    Exit Sub
errHandler:
    ErrorIn "frmAbout.cmdOK_Click", , EA_EXTERNCALL
    HandleError
End Sub

Private Sub FromHSV(H As Single, s As Single, V As Single, ByRef R As Single, ByRef G As Single, ByRef B As Single)
    On Error GoTo errHandler
    Dim i As Single, F As Single, P As Single, q As Single, t As Single
    If V = 0 Then
        R = 0: G = 0: B = 0
    ElseIf s = 0 Then
        R = V: G = V: B = V
    Else
        If H = 1 Then H = 0
        i = Fix(H * 6)
        F = H * 6 - i
        P = V * (1 - s)
        q = V * (1 - s * F)
        t = V * (1 - s * (1 - F))
        Select Case i
            Case 0: R = V: G = t: B = P
            Case 1: R = q: G = V: B = P
            Case 2: R = P: G = V: B = t
            Case 3: R = P: G = q: B = V
            Case 4: R = t: G = P: B = V
            Case 5: R = V: G = P: B = q
        End Select
    End If
    Exit Sub
errHandler:
    ErrorIn "frmAbout.FromHSV(H,s,V,R,G,B)", Array(H, s, V, R, G, B)
End Sub

Private Sub CreateLine(strText As String)
    On Error GoTo errHandler
    Dim l As Long
    Dim H As Single, s As Single, V As Single
    Dim R As Single, G As Single, B As Single
    
    l = lblPersons.UBound
    
    s = 0.7
    V = 1#
    H = CSng(l) * 0.085
    H = H - Fix(H)
    FromHSV H, s, V, R, G, B
    
    If Trim(strText) <> "" Then
        If sngCurTop > 0 Then
            l = l + 1
            Load lblPersons(l)
        End If
          
        
        With lblPersons(l)
            If l > 0 Then .Top = lblPersons(0).Top + sngCurTop
            .Width = frScrollRegion.Width
            .Left = 0
            .Caption = strText
            .ForeColor = RGB(R * 255, G * 255, B * 255)
            .BackColor = 0
            .Visible = True
        End With
        sngCurTop = sngCurTop + lblPersons(0).Height
    Else
        sngCurTop = sngCurTop + lblPersons(0).Height / 2 'en halv linie ved tomme linie
    End If
    Exit Sub
errHandler:
    ErrorIn "frmAbout.CreateLine(strText)", strText
End Sub

'Private Function testingerror(strTest As String) As Boolean
'    On Error GoTo errHandler
'    testingerror = 10 / 0
'
'    Exit Function
'errHandler:
'    ErrorIn "frmAbout.testingerror(strTest)", strTest
'End Function

Private Sub Form_Load()
    On Error GoTo errHandler
    Dim sngLineHeight As Single

    Dim l As Long
    Dim lColorIdx As Long
    Dim lNumLines As Long
    Dim strTemp As String
    Dim lPos As Long
    
    sngCurTop = 0
    lblVersion.Caption = "Version " & App.Major & "." & App.Minor & "." & App.Revision
    Randomize
    
    frScrollRegion.Top = frScrollClipper.Height
    frScrollRegion.BorderStyle = vbBSNone
    
    Persons = "Thanks to everyone who helped us beta-test MonkeyTerm and came up with cool new ideas.||" & _
        "Quale for putting a lot of efford into writing scripts, testing functionality and coming up with ideas.||" & _
        "Wingnut for taking the time to write a website about MonkeyTerm aimed for a more general audience and helping with beta-testing.||" & _
        "GlassWillow for making neat graphics for us.||" & _
        "Nuke, Ardanwen and Fester for their help with beta-testing version 2.||" & _
        "Siobahn and Gk for believing in MonkeyTerm and getting cracked up by the monkey sounds :)||" & _
        "Paddington, for using MonkeyTerm since 1999 :) even while we didn't have time to work on it.||" & _
        "Ecto another early user, who helped us catch some of the first bugs.||" & _
        "Haplo for playing around with it, and help with the initial installer that didn't work too well ;)||" & _
        "Angel, Jingizu, Private, Tamood, Kermit, Dante, Frost, David, Bran, Daniel, Sinseone, Gohan, Lancer, " & _
        "Sadness, Dread, Gasper and everyone we forgot to mention for helping with ideas :)||" & _
        "Greetings goes out to all of AstroMUD and especially the wacky guys and girls in Clan Eternals."
    
    PersonList = Split(Persons, "|")
            
    For l = 0 To UBound(PersonList)
        If Len(PersonList(l)) < CharsPrLine Then
            CreateLine PersonList(l)
        Else
            strTemp = PersonList(l)
            While Len(Trim(strTemp)) > 0
                lPos = InStrRev(strTemp, " ", CharsPrLine)
                If lPos < 1 Then lPos = CharsPrLine
                If lPos > Len(strTemp) Then lPos = Len(strTemp)
                CreateLine Trim(Left(strTemp, lPos))
                strTemp = Right(strTemp, Len(strTemp) - lPos)
            Wend
        End If
    Next
    frScrollRegion.Height = lblPersons(lblPersons.UBound).Top + lblPersons(lblPersons.UBound).Height
    'testingerror "funfun"
    Exit Sub
errHandler:
    ErrorIn "frmAbout.Form_Load", , EA_EXTERNCALL
    HandleError
End Sub


Private Sub AboutTimer_Timer()
    On Error GoTo errHandler
    If frScrollRegion.Top + frScrollRegion.Height < 0 Then
        frScrollRegion.Top = frScrollClipper.Height
    Else
        frScrollRegion.Top = frScrollRegion.Top - Me.ScaleY(1, vbPixels, Me.ScaleMode)
    End If
    Exit Sub
errHandler:
    ErrorIn "frmAbout.AboutTimer_Timer", , EA_EXTERNCALL
    HandleError
End Sub


