VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form frmActions 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Actions"
   ClientHeight    =   5625
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   9915
   Icon            =   "frmActions.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5625
   ScaleWidth      =   9915
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CheckBox Active 
      Caption         =   "Active"
      Height          =   255
      Left            =   8880
      TabIndex        =   9
      Top             =   3960
      Value           =   1  'Checked
      Width           =   855
   End
   Begin VB.CheckBox CaseSensitive 
      Caption         =   "Case sensitive"
      Height          =   255
      Left            =   6240
      TabIndex        =   2
      Top             =   3960
      Width           =   1335
   End
   Begin MSComctlLib.ListView ListView 
      Height          =   5295
      Left            =   120
      TabIndex        =   8
      Top             =   120
      Width           =   5895
      _ExtentX        =   10398
      _ExtentY        =   9340
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   0   'False
      HideSelection   =   0   'False
      FullRowSelect   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   2
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Action"
         Object.Width           =   5186
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Key             =   "Commands"
         Text            =   "Commands"
         Object.Width           =   5080
      EndProperty
   End
   Begin VB.CommandButton DoneButton 
      Caption         =   "&Done"
      Height          =   375
      Left            =   8520
      TabIndex        =   6
      TabStop         =   0   'False
      Top             =   5040
      Width           =   1215
   End
   Begin VB.CommandButton DeleteButton 
      Caption         =   "D&elete"
      Height          =   375
      Left            =   6240
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   4440
      Width           =   1215
   End
   Begin VB.TextBox Action 
      Height          =   285
      Left            =   6240
      TabIndex        =   0
      Top             =   360
      Width           =   3495
   End
   Begin VB.CommandButton UpdateButton 
      Caption         =   "&Update"
      Height          =   375
      Left            =   8520
      TabIndex        =   5
      Top             =   4440
      Width           =   1215
   End
   Begin VB.TextBox Commands 
      Height          =   2895
      Left            =   6240
      MultiLine       =   -1  'True
      TabIndex        =   1
      Top             =   960
      Width           =   3495
   End
   Begin VB.Label lblCommands 
      Caption         =   "Commands:"
      Height          =   255
      Left            =   6240
      TabIndex        =   7
      Top             =   720
      Width           =   1455
   End
   Begin VB.Label lblAction 
      Caption         =   "Action:"
      Height          =   255
      Left            =   6240
      TabIndex        =   4
      Top             =   120
      Width           =   1935
   End
End
Attribute VB_Name = "frmActions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Session As frmSession
Private lViewedInDetailsIndex As Long

Private Const NewName = " < New > "

Public Sub BindTo(SessionForm As frmSession)
    Dim lng As Long
    Set Session = SessionForm
    UpdateListView
    UpdateDetails
End Sub

Private Sub UpdateListView()
    Dim lng As Long
    Dim itm As ListItem
    Dim lSelIdx As Long
    lSelIdx = -1
    If Not ListView.SelectedItem Is Nothing Then lSelIdx = ListView.SelectedItem.Index
    
    'Adjust List Length so that it matches the length of Actions
    If ListView.ListItems.Count > Session.CmdHandler.Actions.Count + 1 Then
        For lng = Session.CmdHandler.Actions.Count + 1 To ListView.ListItems.Count - 1
            ListView.ListItems.Remove ListView.ListItems.Count
        Next
    ElseIf ListView.ListItems.Count <= Session.CmdHandler.Actions.Count + 1 Then
        For lng = ListView.ListItems.Count To Session.CmdHandler.Actions.Count 'ok
            ListView.ListItems.Add
        Next
    End If

    With Session.CmdHandler.Actions
        For lng = 0 To .Count - 1
            Set itm = ListView.ListItems(lng + 1)
            itm.Text = .ItemAction(lng)
            itm.ListSubItems.Clear
            itm.ListSubItems.Add , "Commands", Replace(.ItemCommand(lng), vbCrLf, "\n")
            itm.ListSubItems.Add , "CollectionKey", lng
        Next
    End With
    Set itm = ListView.ListItems(ListView.ListItems.Count)
    itm.ListSubItems.Clear
    itm.Text = NewName
    itm.ListSubItems.Add , "Commands", ""
    itm.ListSubItems.Add , "CollectionKey", -1

    'If lSelIdx > ListView.ListItems.Count Or lSelIdx = -1 Then
    '    lSelIdx = ListView.ListItems.Count
    '    ListView_ItemClick ListView.ListItems(lSelIdx)
    'End If
    
    ListView.Refresh
End Sub

Private Sub UpdateDetails()
    With Session.CmdHandler.Actions
        If SelectedAction = -1 Then
            UpdateButton.Caption = "&Add"
            Action.Text = ""
            Commands.Text = ""
            CaseSensitive.Value = False
            Active.Value = 1
            DeleteButton.Enabled = False
        Else
            UpdateButton.Caption = "&Update"
            Action.Text = .ItemAction(SelectedAction)
            Commands.Text = Replace(Replace(.ItemCommand(SelectedAction), vbCr, ""), vbLf, vbCrLf)
            CaseSensitive.Value = (.ItemCompareMethod(SelectedAction) = vbBinaryCompare) And 1
            Active.Value = (.ItemEnabled(SelectedAction)) And 1
            DeleteButton.Enabled = True
            lViewedInDetailsIndex = SelectedAction
        End If
    End With
End Sub

Private Sub SaveDetails()
    With Session.CmdHandler.Actions
        If Trim(Action.Text) <> "" Or (Action.Text = NewName) Then
            If UpdateButton.Caption = "&Add" Then
                .Add Trim(Action.Text), Commands.Text, (Active.Value = 1), CLng(Not (CaseSensitive.Value)) And 1
            Else
                .ItemAction(lViewedInDetailsIndex) = Trim(Action.Text)
                .ItemCommand(lViewedInDetailsIndex) = Commands.Text
                .ItemCompareMethod(lViewedInDetailsIndex) = CLng(Not (CaseSensitive.Value)) And 1
                .ItemEnabled(lViewedInDetailsIndex) = (Active.Value = 1)
            End If
            UpdateListView
        Else
            Application.Media.Beep 2
        End If
    End With
End Sub

Private Property Get SelectedAction() As Long
    Dim Item As ListItem
    Set Item = ListView.SelectedItem
    If Item Is Nothing Then
        Set Item = ListView.ListItems(ListView.ListItems.Count)
        ListView_ItemClick Item
    End If
    SelectedAction = ListView.SelectedItem.ListSubItems("CollectionKey")
End Property

Private Sub Form_Unload(Cancel As Integer)
    'If Session.CmdHandler.AutoUpdate Then SaveDetails
    SaveDetails
End Sub

Private Sub ListView_ItemClick(ByVal Item As MSComctlLib.ListItem)
    'If Session.CmdHandler.AutoUpdate Then SaveDetails
    SaveDetails
    UpdateDetails
End Sub

Private Sub Commands_KeyDown(KeyCode As Integer, Shift As Integer)
    If (KeyCode = vbKeyEscape) And (Shift = 0) Then
        Commands.SelText = Chr(27)
    End If
End Sub

Private Sub DeleteButton_Click()
    Session.CmdHandler.Actions.Remove (SelectedAction)
    UpdateListView
    UpdateDetails
End Sub

Private Sub DoneButton_Click()
    'If Session.CmdHandler.AutoUpdate Then SaveDetails
    Unload Me
End Sub

Private Sub UpdateButton_Click()
    On Error GoTo ErrorHandler
    SaveDetails
    UpdateListView
    UpdateDetails
Exit Sub
ErrorHandler:
    If Err.Number = Regexp_SyntaxError Then
        MsgBox "Syntax Error in regular expression", vbExclamation, App.EXEName
    End If
    UpdateListView
End Sub



