VERSION 5.00
Begin VB.Form frmApplicationSettings 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Application Settings"
   ClientHeight    =   3735
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7005
   Icon            =   "frmApplicationSettings.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3735
   ScaleWidth      =   7005
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkShowTip 
      Caption         =   "Show Tip at startup"
      Height          =   375
      Left            =   360
      TabIndex        =   11
      Top             =   960
      Width           =   2775
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   5040
      TabIndex        =   10
      Top             =   3240
      Width           =   855
   End
   Begin VB.CheckBox chkSaveOnExit 
      Caption         =   "Save sessions when MT close"
      Height          =   375
      Left            =   360
      TabIndex        =   9
      Top             =   360
      Width           =   2895
   End
   Begin VB.CheckBox chkOpenConnDialogOnLoad 
      Caption         =   "Open connection dialog on load"
      Height          =   255
      Left            =   360
      TabIndex        =   8
      Top             =   720
      Width           =   2895
   End
   Begin VB.Frame frmWebServer 
      Caption         =   "Web server"
      Height          =   2655
      Left            =   3720
      TabIndex        =   1
      Top             =   240
      Width           =   3135
      Begin VB.CommandButton cmdWebStartStop 
         Caption         =   "start/stop"
         Height          =   375
         Left            =   720
         TabIndex        =   7
         Top             =   1800
         Width           =   1935
      End
      Begin VB.TextBox txtWebPort 
         Alignment       =   1  'Right Justify
         Height          =   285
         Left            =   2160
         TabIndex        =   6
         Text            =   "80"
         Top             =   720
         Width           =   855
      End
      Begin VB.TextBox txtWebAcceptIPs 
         Alignment       =   1  'Right Justify
         Height          =   285
         Left            =   1440
         TabIndex        =   5
         Text            =   "127.0."
         Top             =   360
         Width           =   1575
      End
      Begin VB.CheckBox chkWebStartWithMT 
         Caption         =   "Start with MonkeyTerm"
         Height          =   255
         Left            =   360
         TabIndex        =   4
         Top             =   1200
         Width           =   2055
      End
      Begin VB.Label Label2 
         Caption         =   "Port:"
         Height          =   255
         Left            =   360
         TabIndex        =   3
         Top             =   720
         Width           =   1215
      End
      Begin VB.Label Label1 
         Caption         =   "IP filter:"
         Height          =   255
         Left            =   360
         TabIndex        =   2
         Top             =   360
         Width           =   975
      End
   End
   Begin VB.CommandButton cmdApply 
      Caption         =   "Apply"
      Height          =   375
      Left            =   6000
      TabIndex        =   0
      Top             =   3240
      Width           =   855
   End
End
Attribute VB_Name = "frmApplicationSettings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdApply_Click()
    ApplyWebServerSettings
    Application.OpenConnDialogOnLoad = chkOpenConnDialogOnLoad.Value
    Application.gSaveOnExit = chkSaveOnExit.Value
    Application.AutoStartWebServer = chkWebStartWithMT.Value
    TipOfTheDay = chkShowTip.Value
    Unload Me
End Sub

Private Sub cmdCancel_Click()
    Unload Me
End Sub

Private Sub cmdWebStartStop_Click()
    ApplyWebServerSettings
    If Left(cmdWebStartStop.Caption, 5) = "Start" Then
        Application.WebServer.StartServer
    Else
        Application.WebServer.StopServer
    End If
    UpdateStartStopWebServer
End Sub

Private Sub Form_Activate()
    chkOpenConnDialogOnLoad.Value = (Application.OpenConnDialogOnLoad And 1)
    chkSaveOnExit.Value = (Application.gSaveOnExit And 1)
    chkWebStartWithMT.Value = (Application.AutoStartWebServer And 1)
    chkShowTip.Value = (TipOfTheDay And 1)
    txtWebAcceptIPs = Application.WebServer.AcceptIPs
    txtWebPort = Application.WebServer.LocalPort '
    UpdateStartStopWebServer
End Sub

Private Sub ApplyWebServerSettings()
    Application.WebServer.AcceptIPs = txtWebAcceptIPs.Text
    If Application.WebServer.LocalPort <> CLng(txtWebPort.Text) Then
        If Application.WebServer.State = sckListening Then Application.WebServer.StopServer
        Application.WebServer.LocalPort = txtWebPort.Text
        If Left(cmdWebStartStop.Caption, 5) <> "Start" Then Application.WebServer.StartServer
    End If
End Sub

Private Sub UpdateStartStopWebServer()
    If Application.WebServer.State = sckListening Then
        cmdWebStartStop.Caption = "Stop server"
    Else
        cmdWebStartStop.Caption = "Start server"
    End If
End Sub

Private Sub txtWebPort_Validate(Cancel As Boolean)
    On Error GoTo ErrorHandler
    txtWebPort.Text = CLng(txtWebPort.Text)
Exit Sub
ErrorHandler:
    Cancel = True
End Sub
