VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form frmScript 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Scripts"
   ClientHeight    =   4680
   ClientLeft      =   150
   ClientTop       =   720
   ClientWidth     =   6735
   ControlBox      =   0   'False
   Icon            =   "frmScript.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4680
   ScaleWidth      =   6735
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton MoveDownButton 
      Caption         =   ""
      BeginProperty Font 
         Name            =   "Wingdings"
         Size            =   12
         Charset         =   2
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   720
      TabIndex        =   7
      Top             =   1680
      Width           =   495
   End
   Begin VB.CommandButton MoveUpButton 
      Caption         =   ""
      BeginProperty Font 
         Name            =   "Wingdings"
         Size            =   12
         Charset         =   2
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   120
      TabIndex        =   6
      Top             =   1680
      Width           =   495
   End
   Begin MSComDlg.CommonDialog dlgCommonDialog 
      Left            =   5280
      Top             =   3240
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton CloseButton 
      Caption         =   "&Done"
      Height          =   375
      Left            =   120
      TabIndex        =   5
      Top             =   4200
      Width           =   1095
   End
   Begin VB.CommandButton EditButton 
      Caption         =   "&Edit"
      Height          =   375
      Left            =   120
      TabIndex        =   4
      Top             =   1080
      Width           =   1095
   End
   Begin VB.CommandButton RefreshButton 
      Caption         =   "&Reload"
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Top             =   3720
      Width           =   1095
   End
   Begin VB.CommandButton RemoveButton 
      Caption         =   "&Remove"
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   600
      Width           =   1095
   End
   Begin VB.CommandButton AddButton 
      Caption         =   "&Add"
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   1095
   End
   Begin MSComctlLib.ListView ScriptList 
      Height          =   4455
      Left            =   1320
      TabIndex        =   0
      Top             =   120
      Width           =   5295
      _ExtentX        =   9340
      _ExtentY        =   7858
      View            =   3
      MultiSelect     =   -1  'True
      LabelWrap       =   0   'False
      HideSelection   =   0   'False
      OLEDragMode     =   1
      OLEDropMode     =   1
      Checkboxes      =   -1  'True
      FullRowSelect   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      OLEDragMode     =   1
      OLEDropMode     =   1
      NumItems        =   2
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Modules"
         Object.Width           =   2117
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "Path"
         Object.Width           =   2540
      EndProperty
   End
   Begin VB.Menu ScriptMenu 
      Caption         =   "Script"
      Begin VB.Menu AddScript 
         Caption         =   "Add"
      End
      Begin VB.Menu RemoveScript 
         Caption         =   "Remove"
      End
      Begin VB.Menu EditScript 
         Caption         =   "Edit"
      End
      Begin VB.Menu break 
         Caption         =   "-"
      End
      Begin VB.Menu RefreshScripts 
         Caption         =   "Refresh"
      End
      Begin VB.Menu CloseScript 
         Caption         =   "Close"
      End
   End
End
Attribute VB_Name = "frmScript"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const strFileFilter = "MonkeyTerm Script (*.mos)|*.mos|All Files (*.*)|*.*"

Private Session As frmSession

Private Sub MoveSelectedItem(lngDeltaY As Long)
    On Error GoTo errHandler
    Dim itmOld As ListItem
    Dim itmNew As ListItem
    Dim lngIdx As Long
    Dim blnChecked As Boolean
    Dim lng As Long
    If (ScriptList.SelectedItem Is Nothing) Then Exit Sub
    Set itmOld = ScriptList.SelectedItem
    blnChecked = itmOld.Checked
    lngIdx = itmOld.Index
    ScriptList.ListItems.Remove (lngIdx)
    lngIdx = lngIdx + lngDeltaY
    If lngIdx < 1 Then lngIdx = 1
    If lngIdx > ScriptList.ListItems.Count + 1 Then lngIdx = ScriptList.ListItems.Count + 1
    Set itmNew = ScriptList.ListItems.Add(lngIdx, , itmOld.Text)
    For lng = 1 To itmOld.ListSubItems.Count
        itmNew.ListSubItems.Add , , itmOld.ListSubItems(lng).Text
    Next
    itmNew.Checked = blnChecked
    itmNew.Selected = True
    Exit Sub
errHandler:
    ErrorIn "frmScript.MoveSelectedItem(lngDeltaY)", lngDeltaY
End Sub

Private Sub UpdateScriptList()
    On Error GoTo errHandler
    Dim lng As Long
    Dim itm As ListItem
    ScriptList.ListItems.Clear
    With Session.CmdHandler.Script.Scripts
        For lng = 0 To .Count - 1
            Set itm = ScriptList.ListItems.Add(, , .ItemName(lng))
            itm.ListSubItems.Add , , .ItemFileName(lng)
            itm.Checked = .ItemEnabled(lng)
            itm.ListSubItems.Add , , lng
        Next
    End With
    Exit Sub
errHandler:
    ErrorIn "frmScript.UpdateScriptList"
End Sub

Public Sub BindTo(SessionForm As frmSession)
    On Error GoTo errHandler
    Set Session = SessionForm
    UpdateScriptList
    Exit Sub
errHandler:
    ErrorIn "frmScript.BindTo(SessionForm)", SessionForm
End Sub

Private Sub AddButton_Click()
    On Error GoTo errHandler
    Dim sFile As String
    Dim sName As String
    Dim lng As Long
    With dlgCommonDialog
        .DialogTitle = "Open"
        .CancelError = False
        .Filter = strFileFilter
        .ShowOpen
        If Len(.FileName) = 0 Then
            Exit Sub
        End If
        sFile = .FileName
        lng = InStr(sFile, ".")
        If lng = 0 Then
            sName = sFile
        Else
            sName = Left(sFile, lng - 1)
        End If
        lng = InStrRev(sName, "\")
        If lng > 0 Then
            sName = Right(sName, Len(sName) - lng)
        End If
        Session.CmdHandler.Script.Scripts.Add sName, Session.CollapsePath(sFile), True
    End With
    UpdateScriptList
    Exit Sub
errHandler:
    ErrorIn "frmScript.AddButton_Click", , EA_EXTERNCALL
    HandleError
End Sub

Private Sub AddScript_Click()
    AddButton_Click
End Sub

Private Sub Command1_Click()
    ScriptList.SelectedItem.Index = 1
End Sub

Private Sub CloseButton_Click()
    On Error GoTo errHandler
    UpdateScriptList
    Session.CmdHandler.Script.ApplyChanges
    Unload Me
    Exit Sub
errHandler:
    ErrorIn "frmScript.CloseButton_Click", , EA_EXTERNCALL
    HandleError
End Sub

Private Sub EditButton_Click()
    On Error GoTo errHandler
    Dim strFile As String, strFile2 As String, strName As String, strExtention As String
    Dim Index As Integer
    Dim lngIndex As Long
    If (ScriptList.SelectedItem Is Nothing) Then Exit Sub
    Index = ScriptList.SelectedItem.Index
    strFile2 = Session.ExpandPath(Session.CmdHandler.Script.Scripts.ItemFileName(Index - 1))
    Application.Media.ShellOpen (strFile2)
    If Err.LastDllError = 1155 Then ' ERROR_NO_ASSOCIATION:  filtypen ikke registreret.
        strExtention = Mid(strFile, InStr(strFile, ".") + 1)
        With dlgCommonDialog
            .DialogTitle = "Open with"
            .CancelError = False
            .ShowOpen
            If Len(.FileName) = 0 Then
                Exit Sub
            End If
            strFile = .FileName
            lngIndex = InStr(strFile, ".")
            If lngIndex = 0 Then
                strName = strFile
            Else
                strName = Left(strFile, lngIndex - 1)
            End If
            lngIndex = InStrRev(strName, "\")
            If lngIndex > 0 Then
                strName = Right(strName, Len(strName) - lngIndex)
            End If
            If UCase(strExtention) = "MOS" Then
                ' Hvis extention = ".mos" s er det normalt script og st i registry default viewer.
                SetScriptfileViewer strFile
                ' Prver igen :)
                Application.Media.ShellOpen (strFile2)
            Else
                ' ben filen denne gang med denne viewer.
                MsgBox "Warning. Not a valid script extention."
                Application.Media.RunShellCommand strFile & " " & strFile2
            End If
        End With
    End If
    
    Exit Sub
errHandler:
    ErrorIn "frmScript.EditButton_Click", , EA_EXTERNCALL
    HandleError
End Sub

Private Sub EditScript_Click()
    Call EditButton_Click
End Sub

Private Sub Form_Load()
    On Error GoTo errHandler
    ScriptList.ColumnHeaders.Item(2).Width = ScriptList.Width - 15 * 6 - ScriptList.ColumnHeaders.Item(1).Width
    Exit Sub
errHandler:
    ErrorIn "frmScript.Form_Load", , EA_EXTERNCALL
    HandleError
End Sub

Private Sub Form_Terminate()
    On Error GoTo errHandler
    Dim lng As Long
    Dim itm As ListItem
    With Session.CmdHandler.Script.Scripts
        For lng = 1 To ScriptList.ListItems.Count
            Set itm = ScriptList.ListItems.Item(lng)
            .Add itm.Text, itm.ListSubItems.Item(1), itm.Checked
        Next
        
    End With
    Exit Sub
errHandler:
    ErrorIn "frmScript.Form_Terminate", , EA_EXTERNCALL
    HandleError
End Sub

Private Sub MoveDownButton_Click()
    On Error GoTo errHandler
    MoveSelectedItem 1
    Exit Sub
errHandler:
    ErrorIn "frmScript.MoveDownButton_Click", , EA_EXTERNCALL
    HandleError
End Sub

Private Sub MoveUpButton_Click()
    On Error GoTo errHandler
    MoveSelectedItem -1
    Exit Sub
errHandler:
    ErrorIn "frmScript.MoveUpButton_Click", , EA_EXTERNCALL
    HandleError
End Sub

Private Sub RefreshButton_Click()
    UpdateScriptList
    Session.CmdHandler.Script.ApplyChanges
End Sub

Private Sub RefreshScripts_Click()
    Call RefreshButton_Click
End Sub

Private Sub RemoveButton_Click()
    On Error GoTo errHandler
    If (ScriptList.SelectedItem Is Nothing) Then Exit Sub
    Session.CmdHandler.Script.Scripts.Remove ScriptList.SelectedItem
    UpdateScriptList
    Exit Sub
errHandler:
    ErrorIn "frmScript.RemoveButton_Click", , EA_EXTERNCALL
    HandleError
End Sub

Private Sub RemoveScript_Click()
    Call RemoveButton_Click
End Sub

Private Sub ScriptList_AfterLabelEdit(Cancel As Integer, NewString As String)
    On Error GoTo errHandler
    Dim lng As Long
    NewString = Trim(NewString)
    If NewString = "" Then
        Cancel = True
        Exit Sub
    End If
    With Session.CmdHandler.Script.Scripts
        lng = .GetIndex(ScriptList.SelectedItem.Text)
        .ItemName(lng) = NewString
    End With
    Exit Sub
errHandler:
    ErrorIn "frmScript.ScriptList_AfterLabelEdit(Cancel,NewString)", Array(Cancel, NewString), _
         EA_EXTERNCALL
    HandleError
End Sub

Private Sub ScriptList_ItemCheck(ByVal Item As MSComctlLib.ListItem)
    On Error GoTo errHandler
    Dim lng As Long
    With Session.CmdHandler.Script.Scripts
        lng = .GetIndex(Item.Text)
        .ItemEnabled(lng) = Item.Checked
    End With
    Exit Sub
errHandler:
    ErrorIn "frmScript.ScriptList_ItemCheck(Item)", Item, EA_EXTERNCALL
    HandleError
End Sub

Private Sub ScriptList_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    On Error GoTo errHandler
    If Button <> vbRightButton Then Exit Sub
    PopupMenu ScriptMenu, , x, y
    Exit Sub
errHandler:
    ErrorIn "frmScript.ScriptList_MouseDown(Button,Shift,X,Y)", Array(Button, Shift, x, y), _
         EA_EXTERNCALL
    HandleError
End Sub


