VERSION 5.00
Begin VB.UserControl DetailsVariable 
   ClientHeight    =   2325
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3735
   ScaleHeight     =   2325
   ScaleWidth      =   3735
   ToolboxBitmap   =   "DetailsVariable.ctx":0000
   Begin VB.TextBox txtName 
      Height          =   285
      Left            =   0
      TabIndex        =   1
      Top             =   240
      Width           =   3495
   End
   Begin VB.TextBox txtValue 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1245
      Left            =   0
      MultiLine       =   -1  'True
      TabIndex        =   0
      Top             =   840
      Width           =   3495
   End
   Begin VB.Label lblName 
      Caption         =   "Variable Name:"
      Height          =   255
      Left            =   0
      TabIndex        =   3
      Top             =   0
      Width           =   1215
   End
   Begin VB.Label Label3 
      Caption         =   "Value:"
      Height          =   255
      Left            =   0
      TabIndex        =   2
      Top             =   600
      Width           =   615
   End
End
Attribute VB_Name = "DetailsVariable"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private oVariable As Collection
Private sKey As String
Public Event Change(objVariable As Collection, ByRef strKey As String)


Public Sub Init(objVariable As Collection, strKey As String)
    On Error GoTo errHandler
    If Not objVariable Is oVariable Then Update 'auto update when necesarry
    Set oVariable = objVariable
    sKey = strKey
    If Not oVariable Is Nothing Then 'if not new
        txtName.Text = oVariable("Name")
        txtValue.Text = oVariable("Value")
    Else
        txtName.Text = ""
        txtValue.Text = ""
    End If
    Exit Sub
errHandler:
    ErrorIn "DetailsVariable.Init(objVariable,strKey)", Array(objVariable, strKey)
End Sub

Private Sub UserControl_ExitFocus()
    On Error GoTo errHandler
    Update 'auto update when necesarry
    Exit Sub
errHandler:
    ErrorIn "DetailsVariable.UserControl_ExitFocus", , EA_EXTERNCALL
    HandleError
End Sub

Private Sub UserControl_Hide()
    On Error GoTo errHandler
    Set oVariable = Nothing
    txtName.Text = ""
    sKey = ""
    Exit Sub
errHandler:
    ErrorIn "DetailsVariable.UserControl_Hide", , EA_EXTERNCALL
    HandleError
End Sub

Private Sub UserControl_Resize()
    On Error Resume Next
    txtName.Width = UserControl.ScaleWidth
    txtValue.Width = UserControl.ScaleWidth
    txtValue.Height = UserControl.ScaleHeight - txtValue.Top
End Sub

Public Sub Update()
    On Error GoTo errHandler
    If (oVariable Is Nothing) Then
        If Trim(txtName.Text) = "" Then Exit Sub
        Set oVariable = New Collection
    Else
        oVariable.Remove "Name"
        oVariable.Remove "Value"
    End If
    
    oVariable.Add txtName.Text, "Name"
    oVariable.Add txtValue.Text, "Value"
    
    RaiseEvent Change(oVariable, sKey)
    Exit Sub
errHandler:
    ErrorIn "DetailsVariable.Update"
End Sub



