VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "StringBuffer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'// This class is basically a string with methods to add information and flush(clear) it.

Private sBuffer As String
Private Const GrowBy = 10000
Private lLength As Long

Public Sub Append(ByVal sString As String)
'// Adds a string to the end of the buffer.
    If lLength + Len(sString) >= Len(sBuffer) Then
        sBuffer = sBuffer & Space(GrowBy + Len(sString))
    End If
    Mid(sBuffer, lLength + 1, lLength + Len(sString)) = sString
    lLength = lLength + Len(sString)
End Sub

Public Sub Flush()
'// Empties the value of the string and reserves 60000 bytes of memory.
    lLength = 0
    If Len(sBuffer) > 60000 Then sBuffer = Space(60000) 'free memory
End Sub

Public Property Get Length() As Long
'// Returns the length of the current buffer string.
    Length = lLength
End Property

Public Function GetString() As String
'// Returns the value of the buffer.
    GetString = Left(sBuffer, lLength)
End Function

