VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmCollectionOrganizer 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Aliases"
   ClientHeight    =   5625
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   9915
   Icon            =   "frmCollectionOrganizer.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5625
   ScaleWidth      =   9915
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdDownPriority 
      Caption         =   ""
      BeginProperty Font 
         Name            =   "Wingdings"
         Size            =   14.25
         Charset         =   2
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   6240
      TabIndex        =   13
      ToolTipText     =   "Lower priority"
      Top             =   5040
      Width           =   375
   End
   Begin VB.CommandButton cmdUpPriority 
      Caption         =   ""
      BeginProperty Font 
         Name            =   "Wingdings"
         Size            =   14.25
         Charset         =   2
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   6240
      TabIndex        =   12
      ToolTipText     =   "Higher priority"
      Top             =   4440
      Width           =   375
   End
   Begin VB.CheckBox CaseSensitive 
      Caption         =   "Case sensitive"
      Height          =   255
      Left            =   6240
      TabIndex        =   11
      Top             =   4080
      Width           =   1335
   End
   Begin VB.CheckBox Active 
      Caption         =   "Active"
      Height          =   255
      Left            =   8880
      TabIndex        =   10
      Top             =   4080
      Value           =   1  'Checked
      Width           =   855
   End
   Begin VB.TextBox txtName 
      Height          =   285
      Left            =   6240
      TabIndex        =   9
      Top             =   360
      Width           =   3495
   End
   Begin VB.CommandButton DoneButton 
      Caption         =   "&Done"
      Height          =   375
      Left            =   8520
      TabIndex        =   4
      TabStop         =   0   'False
      Top             =   5040
      Width           =   1215
   End
   Begin VB.CommandButton DeleteButton 
      Caption         =   "D&elete"
      Height          =   375
      Left            =   7200
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   4440
      Width           =   1215
   End
   Begin VB.TextBox txtPattern 
      Height          =   285
      Left            =   6240
      TabIndex        =   0
      Top             =   960
      Width           =   3495
   End
   Begin VB.CommandButton UpdateButton 
      Caption         =   "&Update"
      Height          =   375
      Left            =   8520
      TabIndex        =   3
      Top             =   4440
      Width           =   1215
   End
   Begin VB.TextBox txtCommand 
      Height          =   2415
      Left            =   6240
      MultiLine       =   -1  'True
      TabIndex        =   1
      Top             =   1560
      Width           =   3495
   End
   Begin MSComctlLib.ListView ListView 
      Height          =   5295
      Left            =   120
      TabIndex        =   7
      Top             =   120
      Width           =   6015
      _ExtentX        =   10610
      _ExtentY        =   9340
      SortKey         =   3
      View            =   3
      LabelEdit       =   1
      Sorted          =   -1  'True
      LabelWrap       =   0   'False
      HideSelection   =   0   'False
      FullRowSelect   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   4
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Name"
         Object.Width           =   2884
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "Pattern"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(3) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   2
         Text            =   "Command"
         Object.Width           =   7382
      EndProperty
      BeginProperty ColumnHeader(4) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Alignment       =   1
         SubItemIndex    =   3
         Text            =   "Priority"
         Object.Width           =   529
      EndProperty
   End
   Begin VB.Label lblName 
      Caption         =   "Name:"
      Height          =   255
      Left            =   6240
      TabIndex        =   8
      Top             =   120
      Width           =   1215
   End
   Begin VB.Label Label4 
      Caption         =   "Commands:"
      Height          =   255
      Left            =   6240
      TabIndex        =   6
      Top             =   1320
      Width           =   1575
   End
   Begin VB.Label Label3 
      Caption         =   "Pattern:"
      Height          =   255
      Left            =   6240
      TabIndex        =   5
      Top             =   720
      Width           =   615
   End
End
Attribute VB_Name = "frmCollectionOrganizer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Session As frmSession
Private oCol As ICollection
Private lViewedInDetailsIndex As Long

Private Const NewName = " < New > "

Public Sub BindTo(SessionForm As frmSession, Collection As ICollection)
    Dim lng As Long
    Dim itm As ListItem
    Dim sngW As Single
    Set Session = SessionForm
    Set oCol = Collection
    Select Case LCase(TypeName(Collection))
        Case "aliascollection": Me.Caption = "Aliases"
        Case "actioncollection": Me.Caption = "Actions"
        Case "substitutecollection": Me.Caption = "Substitutes"
    End Select

    Set itm = ListView.ListItems.Add
    itm.ListSubItems.Clear
    itm.Text = NewName
    itm.ListSubItems.Add , "Pattern", ""
    itm.ListSubItems.Add , "Commands", ""
    itm.ListSubItems.Add , "CollectionKey", Right(Space(5) & "-1", 5)

    sngW = ListView.Width - 15 * 5

    ListView.ColumnHeaders(1).Width = sngW * 3 / 10
    ListView.ColumnHeaders(2).Width = sngW * 3 / 10
    ListView.ColumnHeaders(3).Width = sngW * 3 / 10
    ListView.ColumnHeaders(4).Width = sngW * 1 / 10

    UpdateListView
    UpdateDetails

End Sub

Private Function FindInListView(lCollectionKey As Long) As ListItem
    Dim lng As Long
    Set FindInListView = Nothing
    For lng = 1 To ListView.ListItems.Count
        If CLng(ListView.ListItems(lng).ListSubItems("CollectionKey")) = lCollectionKey Then
            Set FindInListView = ListView.ListItems(lng)
            Exit Function
        End If
    Next
End Function

Private Function CleanUpListView()
    'remove those that aren't in the collection (except <new>)
    Dim lng As Long
    Dim lColKey As Long
    For lng = ListView.ListItems.Count To 1 Step -1
        lColKey = CLng(ListView.ListItems(lng).ListSubItems("CollectionKey"))
        If lColKey <> -1 Then
            If oCol.GetIndex(lColKey) = -1 Then
                ListView.ListItems.Remove lng
            End If
        End If
    Next
End Function

Private Sub UpdateListView()
    Dim lng As Long
    Dim itm As ListItem
    Dim lSelIdx As Long
    lSelIdx = -1
    If Not ListView.SelectedItem Is Nothing Then lSelIdx = ListView.SelectedItem.Index
    
    CleanUpListView

    With oCol
        For lng = 0 To .Count - 1
            Set itm = FindInListView(lng)
            If itm Is Nothing Then
                Set itm = ListView.ListItems.Add
            End If
            itm.Text = .Item(lng).Name
            itm.ListSubItems.Clear
            itm.ListSubItems.Add , "Pattern", .Item(lng).Pattern
            itm.ListSubItems.Add , "Command", Replace(.Item(lng).Command, vbCrLf, "\n")
            itm.ListSubItems.Add , "CollectionKey", Right(Space(5) & lng, 5)
        Next
    End With

    ListView.Refresh
End Sub

Private Sub UpdateDetails()
    With oCol
        If SelectedColItem = -1 Then
            UpdateButton.Caption = "&Add"
            Active.Value = 1
            CaseSensitive.Value = 0
            txtName.Text = ""
            txtPattern.Text = ""
            txtCommand.Text = ""
            DeleteButton.Enabled = False
        Else
            UpdateButton.Caption = "&Update"
            Active.Value = .Item(SelectedColItem).Enabled And 1
            CaseSensitive.Value = .Item(SelectedColItem).CaseSensitive And 1
            txtPattern.Text = .Item(SelectedColItem).Pattern
            txtName.Text = .Item(SelectedColItem).Name
            txtCommand.Text = Replace(Replace(.Item(SelectedColItem).Command, vbCr, ""), vbLf, vbCrLf)
            DeleteButton.Enabled = True
            lViewedInDetailsIndex = SelectedColItem
        End If
    End With
End Sub

Private Sub SaveDetails()
    With oCol
        If Trim(txtName.Text & txtPattern.Text) <> "" Or (txtName.Text = NewName) Then
            If UpdateButton.Caption = "&Add" Then
                .Add Trim(txtName.Text), txtPattern.Text, txtCommand.Text, (CaseSensitive.Value = 1), (Active.Value = 1)
            Else
                .Item(lViewedInDetailsIndex).Enabled = (Active.Value = 1)
                .Item(lViewedInDetailsIndex).CaseSensitive = (CaseSensitive.Value = 1)
                .Item(lViewedInDetailsIndex).Pattern = txtPattern.Text
                .Item(lViewedInDetailsIndex).Name = txtName.Text
                .Item(lViewedInDetailsIndex).Command = txtCommand.Text
            End If
            UpdateListView
        Else
            Application.Media.Beep 2
        End If
    End With
End Sub

Private Property Get SelectedColItem() As Long
    Dim Item As ListItem
    Set Item = ListView.SelectedItem
    If Item Is Nothing Then
        Set Item = ListView.ListItems(ListView.ListItems.Count)
        ListView_ItemClick Item
    End If
    SelectedColItem = CLng(ListView.SelectedItem.ListSubItems("CollectionKey"))
End Property

Private Sub cmdDownPriority_Click()
    Dim i1 As Long
    Dim i2 As Long
    i1 = SelectedColItem
    i2 = i1 + 1
    If i2 < oCol.Count Then
        SaveDetails
        oCol.Swap i1, i2
        lViewedInDetailsIndex = i2
        FindInListView(i2).ListSubItems("CollectionKey") = Right(Space(5) & i1, 5)
        FindInListView(i1).ListSubItems("CollectionKey") = Right(Space(5) & i2, 5)
        FindInListView(i2).Selected = True
        UpdateListView
    End If
End Sub

Private Sub cmdUpPriority_Click()
    Dim i1 As Long
    Dim i2 As Long
    i1 = SelectedColItem
    i2 = i1 - 1
    If i2 >= 0 Then
        SaveDetails
        oCol.Swap i1, i2
        lViewedInDetailsIndex = i2
        FindInListView(i2).ListSubItems("CollectionKey") = Right(Space(5) & i1, 5)
        FindInListView(i1).ListSubItems("CollectionKey") = Right(Space(5) & i2, 5)
        FindInListView(i2).Selected = True
        UpdateListView
    End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
    'If Session.CmdHandler.AutoUpdate Then SaveDetails
    SaveDetails
End Sub

Private Sub ListView_ColumnClick(ByVal ColumnHeader As MSComctlLib.ColumnHeader)
    If ListView.SortKey = ColumnHeader.Index Then
        If ListView.SortOrder = lvwAscending Then
            ListView.SortOrder = lvwDescending
        Else
            ListView.SortOrder = lvwAscending
        End If
    End If
    ListView.SortKey = ColumnHeader.Index - 1
    ListView.Sorted = True
End Sub

Private Sub ListView_ItemClick(ByVal Item As MSComctlLib.ListItem)
    'If Session.CmdHandler.AutoUpdate Then SaveDetails
    SaveDetails
    UpdateDetails
End Sub

Private Sub Commands_KeyDown(KeyCode As Integer, Shift As Integer)
    If (KeyCode = vbKeyEscape) And (Shift = 0) Then
        Commands.SelText = Chr(27)
    End If
End Sub

Private Sub DeleteButton_Click()
    oCol.Remove (SelectedColItem)
    UpdateListView
    UpdateDetails
End Sub

Private Sub DoneButton_Click()
    'If Session.CmdHandler.AutoUpdate Then SaveDetails
    Unload Me
End Sub


Private Sub ListView_KeyUp(KeyCode As Integer, Shift As Integer)
    If KeyCode = vbKeyDelete And Shift = 0 Then
        DeleteButton_Click
    End If
End Sub

Private Sub txtPattern_LostFocus()
    If txtName.Text = "" Then
        txtName.Text = txtPattern.Text
    End If
End Sub

Private Sub UpdateButton_Click()
    On Error GoTo ErrorHandler
    SaveDetails
    UpdateListView
    UpdateDetails
Exit Sub
ErrorHandler:
    If Err.Number = Regexp_SyntaxError Then
        MsgBox "Syntax Error in regular expression", vbExclamation, App.EXEName
    End If
    UpdateListView
End Sub




