VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "Mscomctl.ocx"
Begin VB.Form frmKeyBindings 
   Caption         =   "Key Bindings"
   ClientHeight    =   5595
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9885
   Icon            =   "frmKeyBindings.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5625
   ScaleMode       =   0  'User
   ScaleWidth      =   9915
   StartUpPosition =   1  'CenterOwner
   Begin MSComctlLib.ListView ListView 
      Height          =   5295
      Left            =   120
      TabIndex        =   7
      Top             =   120
      Width           =   5877
      _ExtentX        =   10372
      _ExtentY        =   9340
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   0   'False
      HideSelection   =   0   'False
      FullRowSelect   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   2
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Keybinding"
         Object.Width           =   2515
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "Command"
         Object.Width           =   7752
      EndProperty
   End
   Begin VB.TextBox Commands 
      Height          =   3255
      Left            =   6240
      MultiLine       =   -1  'True
      TabIndex        =   4
      Top             =   960
      Width           =   3495
   End
   Begin VB.CommandButton UpdateButton 
      Caption         =   "&Update"
      Height          =   375
      Left            =   8520
      TabIndex        =   3
      Top             =   4440
      Width           =   1215
   End
   Begin VB.TextBox KeyCombination 
      Height          =   285
      Left            =   6240
      TabIndex        =   2
      Top             =   360
      Width           =   3495
   End
   Begin VB.CommandButton DeleteButton 
      Caption         =   "D&elete"
      Height          =   375
      Left            =   6240
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   4440
      Width           =   1215
   End
   Begin VB.CommandButton DoneButton 
      Caption         =   "&Done"
      Height          =   375
      Left            =   8520
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   5040
      Width           =   1215
   End
   Begin VB.Label Label3 
      Caption         =   "Key combination:"
      Height          =   255
      Left            =   6240
      TabIndex        =   6
      Top             =   120
      Width           =   1935
   End
   Begin VB.Label Label4 
      Caption         =   "Commands:"
      Height          =   255
      Left            =   6240
      TabIndex        =   5
      Top             =   720
      Width           =   1455
   End
End
Attribute VB_Name = "frmKeyBindings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Session As frmSession

Private CurKeyCode As Integer
Private CurShift As Integer

Private lViewedInDetailsIndex As Long

Private Const NewName = " < New > "

Public Sub BindTo(SessionForm As frmSession)
    On Error GoTo errHandler
    Dim lng As Long
    Set Session = SessionForm
    UpdateListView
    UpdateDetails
    Exit Sub
errHandler:
    ErrorIn "frmKeyBindings.BindTo(SessionForm)", SessionForm
End Sub

Private Function FindInListView(lKeybinding As Long) As ListItem
    On Error GoTo errHandler
    Dim lng As Long
    Set FindInListView = Nothing
    For lng = 1 To ListView.ListItems.Count
        If CLng(ListView.ListItems(lng).ListSubItems("CollectionKey")) - 1 = lKeybinding Then
            Set FindInListView = ListView.ListItems(lng)
            Exit Function
        End If
    Next
    Exit Function
errHandler:
    ErrorIn "frmKeyBindings.FindInListView(lKeybinding)", lKeybinding
End Function

Private Sub UpdateListView()
    On Error GoTo errHandler
    Dim lng As Long
    Dim itm As ListItem
    Dim lSelIdx As Long
    lSelIdx = -1
    If Not ListView.SelectedItem Is Nothing Then lSelIdx = ListView.SelectedItem.Index
    
    'Adjust List Length so that it matches the length of Keybindings
    If ListView.ListItems.Count > Session.KeyBindings.Count + 1 Then
        For lng = Session.KeyBindings.Count + 1 To ListView.ListItems.Count - 1
            ListView.ListItems.Remove ListView.ListItems.Count
        Next
    ElseIf ListView.ListItems.Count <= Session.KeyBindings.Count + 1 Then
        For lng = ListView.ListItems.Count To Session.KeyBindings.Count 'ok
            ListView.ListItems.Add
        Next
    End If

    With Session.KeyBindings
        For lng = 0 To .Count - 1
            Set itm = ListView.ListItems(lng + 1)
            itm.Text = .Item(CLng(lng)).GetKeyCombination
            itm.ListSubItems.Clear
            itm.ListSubItems.Add , "Commands", Replace(.Item(CLng(lng)).Command, vbCrLf, "\n")
            itm.ListSubItems.Add , "CollectionKey", lng
        Next
    End With
    Set itm = ListView.ListItems(ListView.ListItems.Count)
    itm.ListSubItems.Clear
    itm.Text = NewName
    itm.ListSubItems.Add , "Commands", ""
    itm.ListSubItems.Add , "CollectionKey", -1

    'If lSelIdx > ListView.ListItems.Count Or lSelIdx = -1 Then
    '    lSelIdx = ListView.ListItems.Count
    '    ListView_ItemClick ListView.ListItems(lSelIdx)
    'End If
    
    ListView.Refresh
    Exit Sub
errHandler:
    ErrorIn "frmKeyBindings.UpdateListView"
End Sub

Private Sub UpdateDetails()
    On Error GoTo errHandler
    With Session.KeyBindings
        If SelectedKeybinding = -1 Then
            UpdateButton.Caption = "&Add"
            KeyCombination.Text = ""
            Commands.Text = ""
            'CaseSensitive.Value = False
            'Active.Value = 1
            DeleteButton.Enabled = False
        Else
            UpdateButton.Caption = "&Update"
            KeyCombination.Text = .Item(SelectedKeybinding).GetKeyCombination
            Commands.Text = Replace(Replace(.Item(SelectedKeybinding).Command, vbCr, ""), vbLf, vbCrLf)
            CurKeyCode = .Item(SelectedKeybinding).KeyCode
            CurShift = .Item(SelectedKeybinding).Shift
            'CaseSensitive.Value = (.ItemCompareMethod(SelectedKeybinding) = vbBinaryCompare) And 1
            'Active.Value = (.ItemEnabled(SelectedKeybinding)) And 1
            DeleteButton.Enabled = True
            lViewedInDetailsIndex = SelectedKeybinding
        End If
    End With
    Exit Sub
errHandler:
    ErrorIn "frmKeyBindings.UpdateDetails"
End Sub

Private Sub SaveDetails()
    On Error GoTo errHandler
    With Session.KeyBindings
        If Trim(KeyCombination.Text) <> "" Or (KeyCombination.Text = NewName) Then
            If UpdateButton.Caption = "&Add" Then
                .Add CurKeyCode, CurShift, Commands.Text, True
            Else
                .Item(CLng(lViewedInDetailsIndex)).KeyCode = CurKeyCode
                .Item(CLng(lViewedInDetailsIndex)).Shift = CurShift
                .Item(CLng(lViewedInDetailsIndex)).Command = Commands.Text
            End If
            UpdateListView
        Else
            Application.Media.Beep 2
        End If
    End With
    Exit Sub
errHandler:
    ErrorIn "frmKeyBindings.SaveDetails"
End Sub

Private Property Get SelectedKeybinding() As Long
    On Error GoTo errHandler
    Dim Item As ListItem
    Set Item = ListView.SelectedItem
    If Item Is Nothing Then
        Set Item = ListView.ListItems(ListView.ListItems.Count)
        ListView_ItemClick Item
    End If
    SelectedKeybinding = ListView.SelectedItem.ListSubItems("CollectionKey")
    Exit Property
errHandler:
    ErrorIn "frmKeyBindings.SelectedKeybinding"
End Property

Private Sub Form_Unload(Cancel As Integer)
    On Error GoTo errHandler
    'If Session.AutoUpdate Then SaveDetails
    SaveDetails
    Exit Sub
errHandler:
    ErrorIn "frmKeyBindings.Form_Unload(Cancel)", Cancel, EA_EXTERNCALL
    HandleError
End Sub

Private Sub ListView_ItemClick(ByVal Item As MSComctlLib.ListItem)
    On Error GoTo errHandler
    'If Session.AutoUpdate Then SaveDetails
    SaveDetails
    UpdateDetails
    Exit Sub
errHandler:
    ErrorIn "frmKeyBindings.ListView_ItemClick(Item)", Item, EA_EXTERNCALL
    HandleError
End Sub


Private Sub Commands_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo errHandler
    If (KeyCode = vbKeyEscape) And (Shift = 0) Then
        Commands.SelText = Chr(27)
    End If
    Exit Sub
errHandler:
    ErrorIn "frmKeyBindings.Commands_KeyDown(KeyCode,Shift)", Array(KeyCode, Shift), EA_EXTERNCALL
    HandleError
End Sub

Private Sub DeleteButton_Click()
    On Error GoTo errHandler
    Session.KeyBindings.Remove (SelectedKeybinding)
    UpdateListView
    UpdateDetails
    Exit Sub
errHandler:
    ErrorIn "frmKeyBindings.DeleteButton_Click", , EA_EXTERNCALL
    HandleError
End Sub

Private Sub DoneButton_Click()
    On Error GoTo errHandler
    'If Session.AutoUpdate Then SaveDetails
    Unload Me
    Exit Sub
errHandler:
    ErrorIn "frmKeyBindings.DoneButton_Click", , EA_EXTERNCALL
    HandleError
End Sub

Private Sub ListView_KeyUp(KeyCode As Integer, Shift As Integer)
    On Error GoTo errHandler
    If (Shift <> 2) Or ((KeyCode <> vbKeyC) And KeyCode <> vbKeyV) Then Exit Sub     ' Check for Ctrl+C or Ctrl+V
    Dim objUser As New clsUserSettings
    Dim strXML As String
    'Dim lngIndex As Long
    Dim intKeyCode As Integer, intShift As Integer, strCommand As String
    
    'lngIndex = SelectedKeybinding
    If KeyCode = vbKeyC Then      ' COPY
        If SelectedKeybinding = -1 Then Exit Sub  ' Don't copy <new> = empty.
        With Session.KeyBindings
            intKeyCode = .Item(SelectedKeybinding).KeyCode
            intShift = .Item(SelectedKeybinding).Shift
            strCommand = Replace(Replace(.Item(SelectedKeybinding).Command, vbCr, ""), vbLf, vbCrLf)
        End With
        strXML = objUser.MakeKeyBinding(.Item(SelectedKeybinding)).xml
        Clipboard.SetText strXML
    Else                          ' PASTE
        strXML = Trim(Clipboard.GetText)
        If Not (objUser.GetKeybinding(strXML, intKeyCode, intShift, strCommand)) Then Exit Sub

        DeleteButton.Enabled = False
        ListView.ListItems(FindInListView(-2).Index).Selected = True ' Add as <new>.
        UpdateButton.Caption = "&Add"
        KeyCombination.Text = Session.KeyBindings.GetKeyCombination(intKeyCode, intShift)
        Commands.Text = Replace(Replace(strCommand, vbCr, ""), vbLf, vbCrLf)
    End If
    Exit Sub
errHandler:
    ErrorIn "frmKeyBindings.ListView_KeyUp(KeyCode,Shift)", Array(KeyCode, Shift), EA_EXTERNCALL
    HandleError
End Sub

Private Sub UpdateButton_Click()
    On Error GoTo ErrorHandler
    SaveDetails
    UpdateListView
    UpdateDetails
Exit Sub
ErrorHandler:
    If Err.Number = Regexp_SyntaxError Then
        MsgBox "Syntax Error in regular expression", vbExclamation, App.EXEName
    End If
    UpdateListView
End Sub

Private Sub KeyCombination_KeyUp(KeyCode As Integer, Shift As Integer)
    On Error GoTo errHandler
    If Not (KeyCode = 16 Or KeyCode = 17 Or KeyCode = 18) Then
        CurKeyCode = KeyCode
        CurShift = Shift
        KeyCombination.Text = Session.KeyBindings.GetKeyCombination(KeyCode, Shift)
    End If
    Exit Sub
errHandler:
    ErrorIn "frmKeyBindings.KeyCombination_KeyUp(KeyCode,Shift)", Array(KeyCode, Shift), _
         EA_EXTERNCALL
    HandleError
End Sub

Private Sub KeyCombination_KeyDown(KeyCode As Integer, Shift As Integer)
    KeyCombination = ""
End Sub

Private Sub KeyCombination_KeyPress(KeyAscii As Integer)
    KeyCombination = ""
End Sub


