VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "mswinsck.ocx"
Begin VB.Form frmSession 
   Caption         =   "frmSession"
   ClientHeight    =   6855
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   10395
   Icon            =   "frmSession.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   6855
   ScaleWidth      =   10395
   WindowState     =   2  'Maximized
   Begin MonkeyTerm.Terminal Terminal 
      Height          =   4815
      Left            =   0
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   0
      Width           =   6015
      _ExtentX        =   10610
      _ExtentY        =   8493
   End
   Begin MonkeyTerm.ResizeBar ResizeBarLR 
      Height          =   1695
      Left            =   6840
      Tag             =   "HIDE"
      Top             =   2520
      Width           =   75
      _ExtentX        =   132
      _ExtentY        =   2990
      MousePointer    =   9
   End
   Begin MonkeyTerm.BrowserControl Browser 
      Height          =   1455
      Left            =   7200
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   720
      Visible         =   0   'False
      Width           =   2775
      _ExtentX        =   1085
      _ExtentY        =   2566
   End
   Begin VB.Timer tmTimers 
      Index           =   0
      Left            =   5880
      Tag             =   "HIDE"
      Top             =   5280
   End
   Begin MonkeyTerm.ResizeBar ResizeBarUD 
      Height          =   30
      Left            =   0
      Tag             =   "HIDE"
      Top             =   5280
      Width           =   5175
      _ExtentX        =   9128
      _ExtentY        =   53
      MousePointer    =   7
   End
   Begin MSComDlg.CommonDialog dlgCommonDialog 
      Left            =   5880
      Tag             =   "HIDE"
      Top             =   5760
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin MSWinsockLib.Winsock Socket 
      Left            =   6480
      Tag             =   "HIDE"
      Top             =   5760
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin VB.TextBox CmdBox 
      BackColor       =   &H00FFFFFF&
      BeginProperty Font 
         Name            =   "Fixedsys"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1095
      IMEMode         =   3  'DISABLE
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Tag             =   "//This is the white chat-window in the bottom of the session window"
      Top             =   5760
      Width           =   5175
   End
End
Attribute VB_Name = "frmSession"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit


Private Enum enmDesignMode
    mtd_NotDesigning = 0
    mtd_ResizeUD = 1
    mtd_ResizeLR = 2
End Enum

Private DesignMode As enmDesignMode

Private Const HistSize = 127

Public Aliases As New AliasCollection
Public Actions As New ActionCollection
Public Substitutes As New SubstituteCollection
Public KeyBindings As New KeyBindingCollection
Public Variables As New Variables
Public Events As New EventCollection
Public Web As New Web

Public Response As New Buffers

Public JumpOnKeyPressed As Boolean
'// When set, the terminal window will jump to bottom when any key is pressed.
Public JumpOnOutput As Boolean
'// When set, the terminal window will jump to bottom when new text is written on the terminal.

Public SaveOnExit As Boolean
'// When set, the session will save before closing.
Public KeepCommand As Boolean
'// When set, the last command will be kept selected in the command-box.

Private bLockKeyboard As Boolean
'should the form send keep keyboard events from reaching the
'child controls? It should when its a keybinding

Public Enum OptionPageEnum
    ope_Connection = 0
    ope_Aliases = 1
    ope_Actions = 2
    ope_Substitutes = 3
    ope_Script = 4
    ope_KeyBindings = 5
    ope_Options = 6
    ope_Variables = 7
End Enum

Public Host As String
'// Name or IP of the host to connect to.
Public Port As Long
'// Port number of the host to connect to.
Private strSessionName As String
Public FileName As String
'// The name to save as when the session is saved.
Private strANSIFilename As String
Private strTXTFilename As String

Public CmdHandler As New CommandHandler
Public WithEvents Protocol As VT100Parser
Attribute Protocol.VB_VarHelpID = -1
Private SessionTree As frmSessionTree
Private History(HistSize) As String
Private CurHistIdx As Long
Private ShowHistIdx As Long

Public Property Let ANSIFilename(strFileName As String)
'// Sets or reads the name of the filename to log to. Can be set with full path or without. If only filename is set, the application.path will be used as path.
    If InStr(strFileName, "\") = 0 Then
        strANSIFilename = App.Path & "\" & strFileName
    Else
        strANSIFilename = strFileName
    End If
End Property

Public Property Get ANSIFilename() As String
    If strANSIFilename = "" Then strANSIFilename = App.Path & "\" & strSessionName & ".ansi"
    ANSIFilename = strANSIFilename
End Property

Public Property Let TXTFilename(strFileName As String)
'// Sets or reads the name of the filename to log to. Can be set with full path or without. If only filename is set, the application.path will be used as path.
    If InStr(strFileName, "\") = 0 Then
        strTXTFilename = App.Path & "\" & strFileName
    Else
        strTXTFilename = strFileName
    End If
End Property

Public Property Get TXTFilename() As String
    If strTXTFilename = "" Then strTXTFilename = App.Path & "\" & strSessionName & ".txt"
    TXTFilename = strTXTFilename
End Property

Public Sub Save(Optional blnSaveAs As Boolean = False)
'// Saves the session. If blnSaveAs is set or if the filename of this session is empty, the user will be prompted for a filename before the save occurs.
On Error GoTo ErrorHandler
    Dim oUserSettings As New clsUserSettings
    If (FileName = "") Or blnSaveAs Then
        With dlgCommonDialog
            .FileName = FileName
            .CancelError = True
            .Flags = .Flags Or cdlOFNExplorer
            .DialogTitle = "Save '" & strSessionName & "' As ..."
            'ToDo: set the flags and attributes of the common dialog control
            .Filter = strFileFilter
            .ShowSave
            If Len(.FileName) = 0 Then
                Exit Sub
            End If
            FileName = .FileName
        End With
    End If
    oUserSettings.Save FileName, Me
    Events.FireEvent EventType:=etOnSave, ParamValues:=Array(FileName, "OK")
    RecentFiles.Add FileName, strSessionName
    Exit Sub
ErrorHandler:
    If Err.Number <> cdlCancel Then
        Events.FireEvent EventType:=etOnSave, ParamValues:=Array(FileName, "NOT OK")
        Err.Raise Err.Number, Err.Source, Err.Description
    End If
End Sub

Public Property Let SessionName(strVal As String)
'// Sets or reads the name of the session.
    strSessionName = strVal
    Me.Caption = strSessionName
End Property

Public Property Get SessionName() As String
    SessionName = strSessionName
End Property

Public Sub ShowOptions(OptionPage As OptionPageEnum)
'// This sub will probably change so don't use it for scripting.
    On Error GoTo errHandler
    Dim frmOptionPage As Form
    Select Case OptionPage
        Case ope_Connection
            Set frmOptionPage = New frmConnection
            frmOptionPage.BindTo Me
        'Case ope_Aliases
            'Set frmOptionPage = New frmCollectionOrganizer
            'frmOptionPage.BindTo Me, CmdHandler.Aliases
        'Case ope_Actions
            'Set frmOptionPage = New frmCollectionOrganizer
            'frmOptionPage.BindTo Me, CmdHandler.Actions
        'Case ope_Substitutes
            'Set frmOptionPage = New frmCollectionOrganizer
            'frmOptionPage.BindTo Me, CmdHandler.Substitutes
        Case ope_Script
            Set frmOptionPage = New frmScript
            frmOptionPage.BindTo Me
        'Case ope_KeyBindings
            'Set frmOptionPage = New frmKeyBindings
            'frmOptionPage.BindTo Me
        Case ope_Options
            Set frmOptionPage = New frmOptions
            frmOptionPage.BindTo Me
        'Case ope_Variables
        '    Set frmOptionPage = New frmVariables
        '    frmOptionPage.BindTo Me
    End Select
    frmOptionPage.Show vbModal
    Exit Sub
errHandler:
    ErrorIn "frmSession.ShowOptions(OptionPage)", OptionPage, EA_EXTERNCALL
    HandleError
End Sub

Public Sub Connect()
'// Will connect to the chosen host on the chosen IP.
    Dim str As String
On Error GoTo ErrorHandler
    str = vbCrLf & "#Connecting to " & Host & " port " & Port & "."
    Terminal.PrintString str
    Socket.Connect Host, Port
Exit Sub
ErrorHandler:
    str = vbCrLf & "#Error connecting to " & Host & " port " & Port & "." & vbCrLf & _
        "#" & Err.Description
    Terminal.PrintString str
End Sub

Public Sub Disconnect()
'// Will disconnect the session from the host.
    Dim str As String
On Error GoTo ErrorHandler
    Socket.Close
    Socket_Close
Exit Sub
ErrorHandler:
    str = vbCrLf & "#Error disconnecting." & vbCrLf & _
        "#" & Err.Description
    Terminal.PrintString str
End Sub

Public Sub EvaluateCommand(strCmd As String, Optional objMatches As Collection = Nothing, Optional Gag As Boolean = False, Optional bReset As Boolean = False)
'// This sub will evaluate a command ;) What it means is basically it will act as if you had typed the command in the command-box, meaning it will parse it for actions first.
'// strCmd is the command to be evaluated. objMatches should be left missing, Gag will cause the command to be supressed (not shown on the terminal). bReset should be left false, but can be used to overwrite the infinite-loop protection (NOT recommended).
    On Error GoTo errHandler
    Dim s As String
    CmdHandler.Execute strCmd, objMatches, bf_MUDResponse, bReset
    s = Response.Buffer(bf_MUDResponse).GetString
    Response.Buffer(bf_MUDResponse).Flush
    If Protocol.LocalEcho And Not Gag Then Protocol.WriteString s
    If (Socket.State = sckConnected) And (Len(s) > 0) Then
        Socket.SendData s
    End If
    Exit Sub
errHandler:
    ErrorIn "frmSession.EvaluateCommand(strCmd,objMatches,Gag,bReset)", Array(strCmd, objMatches, Gag, _
         bReset), EA_EXTERNCALL
    HandleError
End Sub

Private Sub Browser_DocumentComplete(ByVal pDisp As Object, URL As Variant)
    On Error GoTo errHandler
    Events.FireEvent etOnDocumentComplete, , Array(URL)
    Exit Sub
errHandler:
    ErrorIn "frmSession.Browser_DocumentComplete(pDisp,URL)", Array(pDisp, URL), EA_EXTERNCALL
    HandleError
End Sub

Private Sub CmdBox_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo errHandler
    Dim strCmd As String
    Dim lPos As Long
    Select Case KeyCode
        Case vbKeyA
            If Shift = 2 Then
                CmdBox.SelStart = 0
                CmdBox.SelLength = Len(CmdBox.Text)
                bLockKeyboard = True
            End If
        Case vbKeyUp
            If CmdBox.SelStart > 0 Then
                If InStrRev(CmdBox.Text, vbLf, CmdBox.SelStart) > 0 Then Exit Sub
            End If
            If ShowHistIdx < HistSize - 1 Then
                If ShowHistIdx = 0 Then History((CurHistIdx + 1) And HistSize) = CmdBox.Text
                ShowHistIdx = ShowHistIdx + 1
                CmdBox.Text = History((CurHistIdx - ShowHistIdx + 1) And HistSize)
                'CmdBox.SelStart = InStr(1, CmdBox.Text, vbLf)
                CmdBox.SelStart = 0
                CmdBox.SelLength = Len(CmdBox.Text)
                bLockKeyboard = True
                KeyCode = 0
            End If
        Case vbKeyDown
            If InStr(CmdBox.SelStart + CmdBox.SelLength + 1, CmdBox.Text, vbLf) > 0 Then Exit Sub
            If ShowHistIdx > 0 Then
                ShowHistIdx = ShowHistIdx - 1
                'If ShowHistIdx = 0 Then
                '    CmdBox.Text = ""
                'Else
                    CmdBox.Text = History((CurHistIdx - ShowHistIdx + 1) And HistSize)
                    CmdBox.SelStart = 0
                    CmdBox.SelLength = Len(CmdBox.Text)
                'End If
                KeyCode = 0
                bLockKeyboard = True
            End If
        Case 13
            If Not (Shift = 2) Then
                If JumpOnKeyPressed Then Terminal.GotoBottom
                bLockKeyboard = True
                'If CmdBox.Text <> vbCrLf Then
                strCmd = CmdBox.Text
                If Protocol.LocalEcho Then
                    If (History(CurHistIdx) <> strCmd) And (strCmd <> "") Then
                        CurHistIdx = (CurHistIdx + 1) And HistSize
                        History(CurHistIdx) = strCmd
                    End If
                    'remove last return
                End If
                EvaluateCommand strCmd & vbCrLf, , , True
                'End If
                If KeepCommand Then
                    CmdBox.Text = strCmd
                    CmdBox.SelStart = 0
                    CmdBox.SelLength = Len(strCmd)
                Else
                    CmdBox.Text = ""
                End If
                ShowHistIdx = 0
                CmdBox.SetFocus
            End If
        Case vbKeyLeft, vbKeyHome, vbKeyRight, vbKeyEnd
        Case Else
            ShowHistIdx = 0
    End Select
    Exit Sub
errHandler:
    ErrorIn "frmSession.CmdBox_KeyDown(KeyCode,Shift)", Array(KeyCode, Shift), EA_EXTERNCALL
    HandleError
End Sub

Private Sub Form_Activate()
    On Error GoTo errHandler
    If Socket.State = sckConnected Then
        Application.tbToolBar.Buttons.Item("Connect").Image = 7
    Else
        Application.tbToolBar.Buttons.Item("Connect").Image = 8
    End If
    Application.mnuTXTLog.Checked = Protocol.IsLogging(WithANSI:=False)
    Application.mnuANSILog.Checked = Protocol.IsLogging(WithANSI:=True)
    Exit Sub
errHandler:
    ErrorIn "frmSession.Form_Activate"
End Sub

Private Sub Form_GotFocus()
' Error when changing desktops...
    On Error Resume Next
    CmdBox.SetFocus
    On Error GoTo 0
End Sub

Private Sub Form_Initialize()
    Dim j As Long
    
    Set Protocol = New VT100Parser
    j = Terminal.Color(1)
    Protocol.Init Terminal
    Response.Init Me
    Me.SaveOnExit = Application.gSaveOnExit
End Sub

Public Sub ShowTree(Optional strPath As String = "")
'// This will bring op the SessionTree, showing the aliases/actions/etc. nodes.
'// If strPath is set, the node with that name will be selected.
    frmSessionTree.Init Me
    If strPath <> "" Then frmSessionTree.OpenNode strPath
    frmSessionTree.Show
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo errHandler
    Dim intIdx As Integer
    bLockKeyboard = False
    intIdx = KeyBindings.GetIndex(KeyCode, Shift)
    If intIdx <> -1 Then
        If Not KeyBindings(intIdx).Enabled Then intIdx = -1
    End If
    If intIdx <> -1 Then
        EvaluateCommand KeyBindings.Item(intIdx).Command, , , True
        bLockKeyboard = True
        Application.MenuBarEnable False
    Else
        Select Case KeyCode
            Case vbKeyTab
                If Me.ActiveControl Is CmdBox Then
                    Terminal.SetFocus
                ElseIf (Me.ActiveControl Is Terminal) And (Browser.Visible) Then
                    Browser.SetFocus
                Else
                    CmdBox.SetFocus
                End If
                bLockKeyboard = True
            Case vbKeyPageUp
                Terminal.Scroll -Terminal.PageHeight
                bLockKeyboard = True
            Case vbKeyPageDown
                Terminal.Scroll Terminal.PageHeight
                bLockKeyboard = True
            Case vbKeyEnd
                If Shift = 2 Then
                    Terminal.GotoBottom
                    bLockKeyboard = True
                End If
        End Select
    End If
    If bLockKeyboard Then KeyCode = 0
    Exit Sub
errHandler:
    ErrorIn "frmSession.Form_KeyDown(KeyCode,Shift)", Array(KeyCode, Shift), EA_EXTERNCALL
    HandleError
End Sub


Private Sub Form_KeyPress(KeyAscii As Integer)
    If bLockKeyboard Then KeyAscii = 0
End Sub

Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
    If bLockKeyboard Then
        KeyCode = 0
        Shift = 0
        Application.MenuBarEnable True
    End If
    bLockKeyboard = False
End Sub

Private Sub Form_Load()
    On Error GoTo errHandler
    Port = 23
    bLockKeyboard = False
    SaveOnExit = True
    DesignMode = mtd_NotDesigning
    CmdHandler.Init Me
    Aliases.Init Me
    Actions.Init Me
    Substitutes.Init Me
    Events.Init Me
    Web.Init Me
    Protocol.TabWidth = 8
    ResizeBarUD.BackColor = Me.BackColor
    ResizeBarLR.BackColor = Me.BackColor
    Exit Sub
errHandler:
    ErrorIn "frmSession.Form_Load", , EA_EXTERNCALL
    HandleError
End Sub

Public Sub Copy()
'// This will copy the selected text to the clipboard.
    On Error GoTo errHandler
    If Me.ActiveControl Is CmdBox Then
        Clipboard.SetText CmdBox.SelText
    ElseIf Me.ActiveControl Is Terminal Then
        Terminal.Copy
    End If
    Exit Sub
errHandler:
    ErrorIn "frmSession.Copy", , EA_EXTERNCALL
    HandleError
End Sub

Public Sub Cut()
'// This will copy the selected text to the clipboard. If the text is in the command-box it will be cut, but on the terminal it will work like a normal copy.
    On Error GoTo errHandler
    If Me.ActiveControl Is CmdBox Then
        Clipboard.SetText CmdBox.SelText
        CmdBox.SelText = ""
    ElseIf Me.ActiveControl Is Terminal Then
        Terminal.Copy
    End If
    Exit Sub
errHandler:
    ErrorIn "frmSession.Cut", , EA_EXTERNCALL
    HandleError
End Sub

Public Sub Paste()
'// This will paste the text from the clipboard to the command-box.
    On Error GoTo errHandler
    If Me.ActiveControl Is CmdBox Then
        CmdBox.SelText = Clipboard.GetText
        CmdBox.SelText = ""
    End If
    Exit Sub
errHandler:
    ErrorIn "frmSession.Paste", , EA_EXTERNCALL
    HandleError
End Sub

Private Sub Form_Resize()
    On Error GoTo errHandler
    Static IsResizing As Boolean

    If (Me.WindowState <> vbMinimized) And (Application.WindowState <> vbMinimized) Then
        If Not IsResizing Then
            IsResizing = True
            UpdateLayout
            IsResizing = False
        End If
    End If
    Exit Sub
errHandler:
    ErrorIn "frmSession.Form_Resize", , EA_EXTERNCALL
    HandleError
End Sub

Public Sub UpdateLayout()
'// This will update the session layout. This might be needed after calls that alters sizes on different objects.
    On Error GoTo errHandler
    Dim FormHeight As Single
    Dim MainWidth As Single
    Dim sngTemp As Single
    FormHeight = Me.ScaleHeight
    MainWidth = Me.ScaleWidth - ResizeBarLR.Width
    
    'If FormHeight < cmdbox.Height Then FormHeight = MinHeight
    'If FormWidth < MinWidth Then FormWidth = MinWidth
    ResizeBarLR.Top = 0
    If Browser.Visible Then MainWidth = Me.ScaleWidth - Browser.Width - ResizeBarLR.Width
    If MainWidth < 0 Then MainWidth = 0
    ResizeBarLR.Height = Me.ScaleHeight
    ResizeBarLR.Left = MainWidth
    If Browser.Visible Then
        Browser.Top = Terminal.Top
        Browser.Height = FormHeight
        Browser.Left = ResizeBarLR.Left + ResizeBarLR.Width
    End If
    '-------------------
    CmdBox.Visible = False
    CmdBox.Top = FormHeight - CmdBox.Height - CmdBox.Left
    sngTemp = MainWidth - CmdBox.Left * 2
    If sngTemp < 0 Then sngTemp = 0
    CmdBox.Width = sngTemp
    CmdBox.Visible = True
    ResizeBarUD.Top = CmdBox.Top - ResizeBarUD.Height
    ResizeBarUD.Width = CmdBox.Width
    Terminal.Width = MainWidth - Terminal.Left * 2
    sngTemp = ResizeBarUD.Top - Terminal.Top
    If sngTemp < 0 Then sngTemp = 0
    Terminal.Height = sngTemp
    Exit Sub
errHandler:
    ErrorIn "frmSession.UpdateLayout", , EA_EXTERNCALL
    HandleError
End Sub


Private Sub Form_Unload(Cancel As Integer)
    On Error Resume Next
    Events.FireEvent etOnClose
'    If Application.SaveOnExit And (SessionName <> "") And SaveOnExit Then
    If (SessionName <> "") And SaveOnExit Then
        Save
    End If
    Application.Sessions.Remove Me
    Set CmdHandler = Nothing
    Set KeyBindings = Nothing
End Sub

Private Sub ApplyDesign(x As Single, y As Single)
    On Error GoTo errHandler
    Dim sngTemp As Long
    Select Case DesignMode
        Case mtd_ResizeUD
            sngTemp = Me.ScaleHeight - y - ResizeBarUD.Height
            If sngTemp < 0 Then sngTemp = Terminal.Top
            If sngTemp > Me.ScaleHeight - ResizeBarUD.Height Then sngTemp = Me.ScaleHeight - ResizeBarUD.Height
            CmdBox.Height = sngTemp
            Form_Resize
        Case mtd_ResizeLR
            sngTemp = Me.ScaleWidth - x - ResizeBarLR.Width
            If sngTemp < 0 Then sngTemp = 0
            If sngTemp > Me.ScaleWidth - ResizeBarLR.Width Then sngTemp = Me.ScaleWidth - ResizeBarLR.Width
            Browser.Width = sngTemp
            Form_Resize
        Case Else
    End Select
    Exit Sub
errHandler:
    ErrorIn "frmSession.ApplyDesign(X,Y)", Array(x, y)
End Sub

'Private Sub ResizeBarLR_DblClick()
'    Browser.Visible = Not Browser.Visible
'    UpdateLayout
'End Sub

Private Sub ResizeBarLR_Click()
    Browser.Visible = Not Browser.Visible
    UpdateLayout
End Sub

Private Sub ResizeBarLR_ResizeEnd(bApply As Boolean, x As Single, y As Single)
    If (x < Me.ScaleWidth - ResizeBarLR.Width * 2) Or Browser.Visible Then
        Browser.Visible = True
        If bApply Then ApplyDesign x, y
    End If
End Sub

Private Sub ResizeBarLR_ResizeMove(x As Single, y As Single)
    ResizeBarLR.Left = x
End Sub

Private Sub ResizeBarLR_ResizeStart(x As Single, y As Single)
    DesignMode = mtd_ResizeLR
End Sub

Private Sub ResizeBarUD_ResizeEnd(bApply As Boolean, x As Single, y As Single)
    On Error GoTo errHandler
    If bApply Then
        ApplyDesign x, y
    End If
    Exit Sub
errHandler:
    ErrorIn "frmSession.ResizeBarUD_ResizeEnd(bApply,X,Y)", Array(bApply, x, y), EA_EXTERNCALL
    HandleError
End Sub

Private Sub ResizeBarUD_ResizeMove(x As Single, y As Single)
    'show it....
    ResizeBarUD.Top = y
End Sub

Private Sub ResizeBarUD_ResizeStart(x As Single, y As Single)
    DesignMode = mtd_ResizeUD
End Sub

Private Sub Socket_Close()
    On Error GoTo errHandler
    Dim str As String
    str = vbCrLf & "#Connection closed."
    Application.tbToolBar.Buttons.Item("Connect").Image = 8
    Terminal.PrintString str
    Socket.Close
    Events.FireEvent etOnDisconnect
    Exit Sub
errHandler:
    ErrorIn "frmSession.Socket_Close", , EA_EXTERNCALL
    HandleError
End Sub

Private Sub Socket_Connect()
    On Error GoTo errHandler
    Dim str As String
    str = vbCrLf & "#Connected to " & Socket.RemoteHost & " port " & Socket.RemotePort & "."
    Terminal.PrintString str
    Application.tbToolBar.Buttons.Item("Connect").Image = 7
    Events.FireEvent etOnConnect
    Exit Sub
errHandler:
    ErrorIn "frmSession.Socket_Connect", , EA_EXTERNCALL
    HandleError
End Sub

Private Sub Socket_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
    On Error GoTo errHandler
    Dim str As String
    str = vbCrLf & "#Error: " & Description & "."
    Terminal.PrintString str
    CancelDisplay = True
    Disconnect
    Exit Sub
errHandler:
    ErrorIn "frmSession.Socket_Error(Number,Description,Scode,Source,HelpFile,HelpContext," & _
        "CancelDisplay)", Array(Number, Description, Scode, Source, HelpFile, HelpContext, CancelDisplay), _
         EA_EXTERNCALL
    HandleError
End Sub

Private Sub Socket_DataArrival(ByVal bytesTotal As Long)
    On Error GoTo errHandler
    Dim s As String
    'Dim t As Single
    't = Timer
    Socket.GetData s
    
    Substitutes.Evaluate s
    s = Protocol.WriteString(s)
    If JumpOnOutput Then
        Terminal.GotoBottom
    End If
    Actions.Evaluate s
    
    
    Exit Sub
errHandler:
    ErrorIn "frmSession.Socket_DataArrival(bytesTotal)", bytesTotal, EA_EXTERNCALL
    HandleError
End Sub

Private Sub Terminal_SelectedText()
    On Error GoTo errHandler
    Events.FireEvent etOnSelectedText
    Exit Sub
errHandler:
    ErrorIn "frmSession.Terminal_SelectedText", , EA_EXTERNCALL
    HandleError
End Sub

Private Sub Terminal_WriteString(sString As String)
    On Error GoTo errHandler
    If Protocol.LocalEcho Then Protocol.WriteString sString
    If Socket.State = sckConnected Then
        Socket.SendData sString
    End If
    If JumpOnKeyPressed Then
        Terminal.GotoBottom
    End If
    Exit Sub
errHandler:
    ErrorIn "frmSession.Terminal_WriteString(sString)", sString, EA_EXTERNCALL
    HandleError
End Sub

Private Sub Terminal_KeyPressed(KeyAscii As Integer)
    On Error GoTo errHandler
    Dim sSend As String
    sSend = Chr(KeyAscii)
    If KeyAscii = 13 Then sSend = vbCrLf
    If Protocol.LocalEcho Then Protocol.WriteString sSend
    If Socket.State = sckConnected Then
        Socket.SendData sSend
    End If
    If JumpOnKeyPressed Then
        Terminal.GotoBottom
    End If
    Exit Sub
errHandler:
    ErrorIn "frmSession.Terminal_KeyPressed(KeyAscii)", KeyAscii, EA_EXTERNCALL
    HandleError
End Sub

Private Sub Protocol_TelnetReply(strCommandSequence As String)
    On Error GoTo errHandler
    If (Socket.State = sckConnected) And (Len(strCommandSequence) > 0) Then
        Socket.SendData strCommandSequence
    End If
    Exit Sub
errHandler:
    ErrorIn "frmSession.Protocol_TelnetReply(strCommandSequence)", strCommandSequence, EA_EXTERNCALL
    HandleError
End Sub

Public Function ExpandPath(ByVal sPath As String) As String
'// This function will take a path and replace any occurances of %AppPath% with the application path and and %SessionPath% with the path of the session file.
    On Error GoTo errHandler
    sPath = Replace(sPath, "%AppPath%", App.Path, , , vbTextCompare)
    sPath = Replace(sPath, "%SessionPath%", GetFolderPath(FileName), , , vbTextCompare)
    ExpandPath = sPath
    Exit Function
errHandler:
    ErrorIn "frmSession.ExpandPath(sPath)", sPath
End Function

Public Function CollapsePath(ByVal sPath) As String
'// This will collapse a path. It reverses the effect of ExpandPath.
    On Error GoTo errHandler
    Dim sEnvStrings(1) As String
    Dim sAppPath As String
    Dim sSessionPath As String
    sAppPath = App.Path
    sSessionPath = GetFolderPath(FileName)
    If Len(sAppPath) >= Len(sSessionPath) Then
        sPath = Replace(sPath, sAppPath, "%AppPath%", , , vbTextCompare)
        sPath = Replace(sPath, sSessionPath, "%SessionPath%", , , vbTextCompare)
    Else
        sPath = Replace(sPath, sSessionPath, "%SessionPath%", , , vbTextCompare)
        sPath = Replace(sPath, sAppPath, "%AppPath%", , , vbTextCompare)
    End If
    CollapsePath = sPath
    Exit Function
errHandler:
    ErrorIn "frmSession.CollapsePath(sPath)", sPath
End Function

Private Function IsTimer(objTimer As Timer) As Boolean
    On Error GoTo ErrorH
    Dim sTag As String
    sTag = objTimer.Tag
    IsTimer = (InStr(sTag, vbCrLf) > 0) 'Timers has 3 vbcrlf separated fields in the tag
    Exit Function
ErrorH:
    IsTimer = False
End Function

Private Function FindTimerIndex(Index) As Integer
On Error GoTo ErrorH
    FindTimerIndex = -1
    'If IsNumeric(Index) Then
    '    FindTimerIndex = Index
    'Else
        Dim intLoop As Integer
        For intLoop = 1 To tmTimers.Count
            If IsTimer(tmTimers(intLoop)) Then
                If Split(tmTimers(intLoop).Tag, vbCrLf)(1) = Index Then
                    FindTimerIndex = intLoop
                    Exit For
                End If
            End If
        Next
    'End If
    Exit Function
ErrorH:
    FindTimerIndex = -1
End Function

Friend Sub NewTimer(TimerName As String, Interval As Single, Optional FireOnce As Boolean = False)
    On Error GoTo errHandler
    Dim intNum As Integer
    
    If Interval < 0 Then Exit Sub ' Must be more than 0 seconds.
    
    
    intNum = FindTimerIndex(TimerName)
    If intNum = -1 Then
        'we need to load a new one
        If tmTimers.Count <= tmTimers.UBound Then
            For intNum = 1 To tmTimers.Count
                If Not IsTimer(tmTimers(intNum)) Then Exit For
            Next
        Else
            intNum = tmTimers.Count
            Load tmTimers(intNum)
        End If
        
    End If
    tmTimers(intNum).Enabled = False 'force a reset if it already exists
    
    tmTimers(intNum).Tag = Interval & vbCrLf & TimerName & vbCrLf & FireOnce
    If CSng(Interval) > 60 Then
        tmTimers(intNum).Interval = 60000 ' 60secs.
    Else
        tmTimers(intNum).Interval = Interval * 1000
    End If
    tmTimers(intNum).Enabled = True
    Exit Sub
errHandler:
    ErrorIn "frmSession.NewTimer(TimerName,Interval,FireOnce)", Array(TimerName, Interval, FireOnce)
End Sub

Friend Sub ResetTimer(Index)
    On Error GoTo errHandler
    Dim intIndex
    
    intIndex = FindTimerIndex(Index)
    If intIndex = -1 Then Exit Sub
    tmTimers(intIndex).Enabled = False
    tmTimers(intIndex).Enabled = True
    Exit Sub
    Exit Sub
errHandler:
    ErrorIn "frmSession.ResetTimer(Index)", Index
End Sub

Friend Sub RemoveUnusedTimers()
    On Error GoTo errHandler
    Dim intIndex As Integer
    Dim sName As String
    Dim oEvent As clsEvent
    For intIndex = tmTimers.LBound To tmTimers.UBound
        If IsTimer(tmTimers(intIndex)) Then
            
            sName = Split(tmTimers.Item(intIndex).Tag & vbCrLf, vbCrLf)(1)
            Set oEvent = Events.Item(sName)
            If oEvent Is Nothing Then
                tmTimers(intIndex).Enabled = False
                tmTimers.Item(intIndex).Tag = ""
                'Unload tmTimers(intIndex)
            Else
                If (oEvent.Enabled = False) Or (oEvent.EventType <> etTimer) Then
                    tmTimers(intIndex).Enabled = False
                    tmTimers.Item(intIndex).Tag = ""
                    'Unload tmTimers(intIndex)
                End If
            End If
        End If
    Next
    Exit Sub
errHandler:
    ErrorIn "frmSession.RemoveUnusedTimers"
End Sub

Private Sub tmTimers_Timer(Index As Integer)
    'On Error GoTo errHandler
    Dim arrValues As Variant
    Dim sngTimer As Single
    Dim blnFireEvent As Boolean
    Dim objEvent As clsEvent
    
    arrValues = Split(tmTimers(Index).Tag, vbCrLf)
    Set objEvent = Events(arrValues(1))
    If (objEvent Is Nothing) Then   ' Event does not exist. Remove timer.
        RemoveUnusedTimers
        Exit Sub
    End If
    
    blnFireEvent = False
    sngTimer = arrValues(0)
    sngTimer = sngTimer - (CSng(tmTimers(Index).Interval) / 1000)   ' Get remaining time.
    
    If sngTimer <= 0 Then   ' Fire event, and reset counters.
        sngTimer = objEvent.GetData("Interval")
        If sngTimer > 60 Then
            tmTimers(Index).Interval = 60000
        Else
            tmTimers(Index).Interval = sngTimer * 1000
        End If
        blnFireEvent = True
    ElseIf sngTimer < 60 Then   ' less than 60secs remaning, update .Interval to remaining.
        tmTimers(Index).Interval = sngTimer * 1000
    End If ' Else make another 60sec. cycle.
    
    arrValues(0) = sngTimer
    tmTimers(Index).Tag = Join(arrValues, vbCrLf)
    
    If blnFireEvent Then
        'If objEvent.GetData("FireOnce") Then RemoveTimer Index
        Events.FireEvent etTimer, objEvent.Name, Array(objEvent.Name)
    End If
    Exit Sub
errHandler:
    ErrorIn "frmSession.tmTimers_Timer(Index)", Index
    If Not objEvent Is Nothing Then objEvent.Enabled = False 'this should trigger a removal of the event
    
End Sub



